
# define TOKEN char
# define VALUE char*
# define STACKTOKENS 1
# define STACKSIZE 2048

# define PRECC_Y /* signal to get precc's special V(x), T(x)  macros */
# include "cc.h"
# include "preccx.h"
# undef UNSETNAME
# include "preamble.h"


        /* -- a shot at C-expressions -- 
           (just in order to count brackets!) */

@ atomexpr = monexpr
@          | fnexpr
@          | arrayexpr
@          | yvar
@          | cvar
@          | constant
@          | cast
@          | brktexpr
@          | brceexpr

@ cast = brkttype { brkttype : VV(2)=V(2); :}* atomexpr :VV(2)=V(2);:

@ atomtype = brkttype
@          | IDENTIFIER

@ type = atomtype { WHITESPACE typeconstruct : VV(3)=V(1); : }*

@ brkttype = openparen WHITESPACE type WHITESPACE closeparen :VV(5)=V(3);:

@ star = STAR : putchar('*'); :

@ typeconstruct = star 
@               | openparen WHITESPACE 
@                 closeparen     :VV(3)=V(1);:
@               | openbracket WHITESPACE [ NUMBER WHITESPACE :VV(3) = V(2);: ]
@                 closebracket :VV(3)=V(1);:

@ cvar = IDENTIFIER

@ yvar = DOLLARID

@ constant = NUMBER
@          | STRING
@          | CHARCONST

@ expr = atomexpr { WHITESPACE binop WHITESPACE expr : VV(5) = V(1); : }*

@ monexpr  = monop WHITESPACE atomexpr : VV(3)=V(1); : 

@ fnexpr   = IDENTIFIER WHITESPACE rdbrktargs : VV(3)=V(1); : 

@ arrayexpr= IDENTIFIER WHITESPACE sqbrexpr :VV(3)=V(1);: 

@ sqbrexpr = openbracket sqbrktelmts closebracket :VV(3)=V(1); :

@ sqbrktelmts = sqbrktelmt sqbrktelmts :VV(2) = V(1);:
@          | /* nothing */      :VV(0)=putname("");:

@ sqbrktelmt =STRING
@         | CHARCONST
@         | DOLLARID
@         | COMMENT
@         | atomexpr
@         | NOTACLOSESQBRKT : VV(1) = putchar(T(1)); :

@ brktexpr = openparen brktelmts closeparen :VV(3)=V(1); :

@ brktelmts= brktelmt brktelmts :VV(2) = V(1);:
@          | /* nothing */      :VV(0)=putname("");:

@ brktelmt =STRING
@         | CHARCONST
@         | DOLLARID
@         | COMMENT
@         | atomexpr
@         | NOTACLOSEPAREN : VV(1) = putchar(T(1)); :

@ brceexpr = openbrace brceelmts closebrace :VV(3)=V(1);:

@ brceelmts= brceelmt brceelmts :VV(2) = V(1);:
@          | /* nothing */      :VV(0)=putname("");:

@ brceelmt =STRING
@         | CHARCONST
@         | DOLLARID
@         | COMMENT
@         | atomexpr
@         | NOTACLOSEBRACE : VV(1) = putchar(T(1)); :

@ comment  = COMMENT

        /* overgenerous - allows arbitrary infixes so long as they have
        the right chars in them */

@ binop    = binopone { binopone : VV(2)=V(1); : }*

@ binopone = BINOPCHAR : VV(1)=putchar(T(1)); :

@ monoptwo = PLUSPLUS :VV(1)=putname("++");: 
@          | MINUSMINUS :VV(1)=putname("--");: 

@ monopone = MONOPCHAR :VV(1)=putchar(T(1));:

@ monop    = monoptwo
@          | monopone

