
# define TOKEN char
# define VALUE char*
# define STACKTOKENS 1
# define STACKSIZE 2048

# define PRECC_Y /* signal to get precc's special V(x), T(x)  macros */
# include "cc.h"
# include "preccx.h"
# undef UNSETNAME
# include "preamble.h"

/* in order to be able to parse .. = <'>'>   !! */
/*                          or  .. = >'<'<      */
# define RIGHT_ANGLE_BRACKET '>'
# define LEFT_ANGLE_BRACKET '<'
/* and use  .. = <RIGHT_ANGLE_BRACKET> instead */
/* or       .. = >LEFT_ANGLE_BRACKET< */

                /* -------- spaces ---------- */

P_BEGIN
static STATUS hid0(PRECC_DATA* self) {
PREDICATE p_isspace;
return p_range0n(self,p_isspace,0);
}
static STATUS hid1 (PRECC_DATA* self) {
PARSER hid0, COMMENT;
return p_orparse0n (self,TOPARSER hid0,0,TOPARSER COMMENT,0);
}
STATUS SPACE(PRECC_DATA* self) {
PARSER hid1;
P_RETURN((TOPARSER hid1)(self),"SPACE");
}
P_END

P_BEGIN
static VOID hid2(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid3(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid2;
return p_attach0n(self,TOPARSER p_nothing0,0,hid2,0);
}
static STATUS hid4(PRECC_DATA* self) {
PARSER hid3, p_nothing0;
return p_andparse0n (self,TOPARSER hid3,0,TOPARSER p_nothing0,0);
}
static STATUS hid5 (PRECC_DATA* self) {
PARSER SOMESPACE, hid4;
return p_orparse0n (self,TOPARSER SOMESPACE,0,TOPARSER hid4,0);
}
STATUS WHITESPACE(PRECC_DATA* self) {
PARSER hid5;
P_RETURN((TOPARSER hid5)(self),"WHITESPACE");
}
P_END

P_BEGIN
static VOID hid6(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid7(PRECC_DATA* self) {
PARSER SPACE;ACTION hid6;
return p_attach0n(self,TOPARSER SPACE,0,hid6,0);
}
static STATUS hid8(PRECC_DATA* self) {
PARSER hid7, p_nothing0;
return p_andparse0n (self,TOPARSER hid7,0,TOPARSER p_nothing0,0);
}
static STATUS hid9(PRECC_DATA* self) {
PARSER hid8;
return p_many0n(self,TOPARSER hid8,0);
}
static STATUS hid10(PRECC_DATA* self) {
PARSER SPACE, hid9;
return p_andparse0n (self,TOPARSER SPACE,0,TOPARSER hid9,0);
}
STATUS SOMESPACE(PRECC_DATA* self) {
PARSER hid10;
P_RETURN((TOPARSER hid10)(self),"SOMESPACE");
}
P_END

                /* -- simple identifiers ------ */

/* read character into the cbuff */
P_BEGIN
static STATUS hid11(PRECC_DATA* self) {
PREDICATE p_isalpha;
return p_range0n(self,p_isalpha,0);
}
static VOID hid12(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid13(PRECC_DATA* self) {
PARSER hid11;ACTION hid12;
return p_attach0n(self,TOPARSER hid11,0,hid12,0);
}
static STATUS hid14(PRECC_DATA* self) {
PARSER hid13, p_nothing0;
return p_andparse0n (self,TOPARSER hid13,0,TOPARSER p_nothing0,0);
}
STATUS alpha(PRECC_DATA* self) {
PARSER hid14;
P_RETURN((TOPARSER hid14)(self),"alpha");
}
P_END

/* append characters to the cbuff */
P_BEGIN
static VOID hid15(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid16(PRECC_DATA* self) {
PARSER alnum;ACTION hid15;
return p_attach0n(self,TOPARSER alnum,0,hid15,0);
}
static STATUS hid17(PRECC_DATA* self) {
PARSER hid16, p_nothing0;
return p_andparse0n (self,TOPARSER hid16,0,TOPARSER p_nothing0,0);
}
static STATUS hid18(PRECC_DATA* self) {
PARSER hid17;
return p_many0n(self,TOPARSER hid17,0);
}
static STATUS hid19(PRECC_DATA* self) {
PARSER alpha, hid18;
return p_andparse0n (self,TOPARSER alpha,0,TOPARSER hid18,0);
}
STATUS IDENTIFIER(PRECC_DATA* self) {
PARSER hid19;
P_RETURN((TOPARSER hid19)(self),"IDENTIFIER");
}
P_END
  
P_BEGIN
static STATUS hid20(PRECC_DATA* self) {
PREDICATE p_isdigit;
return p_range0n(self,p_isdigit,0);
}
static VOID hid21(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid22(PRECC_DATA* self) {
PARSER hid20;ACTION hid21;
return p_attach0n(self,TOPARSER hid20,0,hid21,0);
}
static STATUS hid23(PRECC_DATA* self) {
PARSER hid22, p_nothing0;
return p_andparse0n (self,TOPARSER hid22,0,TOPARSER p_nothing0,0);
}
STATUS digit(PRECC_DATA* self) {
PARSER hid23;
P_RETURN((TOPARSER hid23)(self),"digit");
}
P_END

P_BEGIN
static STATUS hid24(PRECC_DATA* self) {
PREDICATE p_isalnum;
return p_range0n(self,p_isalnum,0);
}
static VOID hid25(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid26(PRECC_DATA* self) {
PARSER hid24;ACTION hid25;
return p_attach0n(self,TOPARSER hid24,0,hid25,0);
}
static STATUS hid27(PRECC_DATA* self) {
PARSER hid26, p_nothing0;
return p_andparse0n (self,TOPARSER hid26,0,TOPARSER p_nothing0,0);
}
STATUS alnum(PRECC_DATA* self) {
PARSER hid27;
P_RETURN((TOPARSER hid27)(self),"alnum");
}
P_END

/* and these are absorbing */

P_BEGIN
static STATUS hid28(PRECC_DATA* self) {
return p_exactly0(self,'[');
}
STATUS OPENBRACKET(PRECC_DATA* self) {
PARSER hid28;
P_RETURN((TOPARSER hid28)(self),"OPENBRACKET");
}
P_END

P_BEGIN
static STATUS hid29(PRECC_DATA* self) {
return p_exactly0(self,']');
}
STATUS CLOSEBRACKET(PRECC_DATA* self) {
PARSER hid29;
P_RETURN((TOPARSER hid29)(self),"CLOSEBRACKET");
}
P_END

P_BEGIN
static STATUS hid30(PRECC_DATA* self) {
return p_exactly0(self,'(');
}
STATUS OPENPAREN(PRECC_DATA* self) {
PARSER hid30;
P_RETURN((TOPARSER hid30)(self),"OPENPAREN");
}
P_END

P_BEGIN
static STATUS hid31(PRECC_DATA* self) {
return p_exactly0(self,')');
}
STATUS CLOSEPAREN(PRECC_DATA* self) {
PARSER hid31;
P_RETURN((TOPARSER hid31)(self),"CLOSEPAREN");
}
P_END

P_BEGIN
static STATUS hid32(PRECC_DATA* self) {
return p_exactly0(self,'{');
}
STATUS OPENBRACE(PRECC_DATA* self) {
PARSER hid32;
P_RETURN((TOPARSER hid32)(self),"OPENBRACE");
}
P_END

P_BEGIN
static STATUS hid33(PRECC_DATA* self) {
return p_exactly0(self,'}');
}
STATUS CLOSEBRACE(PRECC_DATA* self) {
PARSER hid33;
P_RETURN((TOPARSER hid33)(self),"CLOSEBRACE");
}
P_END

P_BEGIN
static STATUS hid34 (PRECC_DATA* self) {
PARSER FLOAT, INTEGER;
return p_orparse0n (self,TOPARSER FLOAT,0,TOPARSER INTEGER,0);
}
static STATUS hid35 (PRECC_DATA* self) {
PARSER OCTINT, hid34;
return p_orparse0n (self,TOPARSER OCTINT,0,TOPARSER hid34,0);
}
static STATUS hid36 (PRECC_DATA* self) {
PARSER HEXINT, hid35;
return p_orparse0n (self,TOPARSER HEXINT,0,TOPARSER hid35,0);
}
STATUS NUMBER(PRECC_DATA* self) {
PARSER hid36;
P_RETURN((TOPARSER hid36)(self),"NUMBER");
}
P_END

P_BEGIN
static STATUS hid37(PRECC_DATA* self) {
PARSER mantissa, optexponent;
return p_andparse0n (self,TOPARSER mantissa,0,TOPARSER optexponent,0);
}
static STATUS hid38(PRECC_DATA* self) {
PARSER integer, hid37;
return p_andparse0n (self,TOPARSER integer,0,TOPARSER hid37,0);
}
static VOID hid39(PRECC_DATA* self) {
 VV(3) = V(1); 
}
static STATUS hid40(PRECC_DATA* self) {
PARSER hid38;ACTION hid39;
return p_attach0n(self,TOPARSER hid38,0,hid39,0);
}
static STATUS hid41(PRECC_DATA* self) {
PARSER hid40, p_nothing0;
return p_andparse0n (self,TOPARSER hid40,0,TOPARSER p_nothing0,0);
}
STATUS FLOAT(PRECC_DATA* self) {
PARSER hid41;
P_RETURN((TOPARSER hid41)(self),"FLOAT");
}
P_END

P_BEGIN
static STATUS hid42(PRECC_DATA* self) {
PARSER integer, optexponent;
return p_andparse0n (self,TOPARSER integer,0,TOPARSER optexponent,0);
}
static VOID hid43(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid44(PRECC_DATA* self) {
PARSER hid42;ACTION hid43;
return p_attach0n(self,TOPARSER hid42,0,hid43,0);
}
static STATUS hid45(PRECC_DATA* self) {
PARSER hid44, p_nothing0;
return p_andparse0n (self,TOPARSER hid44,0,TOPARSER p_nothing0,0);
}
STATUS INTEGER(PRECC_DATA* self) {
PARSER hid45;
P_RETURN((TOPARSER hid45)(self),"INTEGER");
}
P_END

P_BEGIN
static STATUS hid46(PRECC_DATA* self) {
PARSER Ox, somehexdigits;
return p_andparse0n (self,TOPARSER Ox,0,TOPARSER somehexdigits,0);
}
static VOID hid47(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid48(PRECC_DATA* self) {
PARSER hid46;ACTION hid47;
return p_attach0n(self,TOPARSER hid46,0,hid47,0);
}
static STATUS hid49(PRECC_DATA* self) {
PARSER hid48, p_nothing0;
return p_andparse0n (self,TOPARSER hid48,0,TOPARSER p_nothing0,0);
}
STATUS HEXINT(PRECC_DATA* self) {
PARSER hid49;
P_RETURN((TOPARSER hid49)(self),"HEXINT");
}
P_END

P_BEGIN
static STATUS hid50(PRECC_DATA* self) {
return p_exactly0(self,'0');
}
static STATUS hid51(PRECC_DATA* self) {
return p_exactly0(self,'x');
}
static STATUS hid52(PRECC_DATA* self) {
return p_exactly0(self,'X');
}
static STATUS hid53 (PRECC_DATA* self) {
PARSER hid51, hid52;
return p_orparse0n (self,TOPARSER hid51,0,TOPARSER hid52,0);
}
static STATUS hid54(PRECC_DATA* self) {
PARSER hid50, hid53;
return p_andparse0n (self,TOPARSER hid50,0,TOPARSER hid53,0);
}
static VOID hid55(PRECC_DATA* self) {
 VV(2)=V(1);putchar(T(1));putchar(T(2)); 
}
static STATUS hid56(PRECC_DATA* self) {
PARSER hid54;ACTION hid55;
return p_attach0n(self,TOPARSER hid54,0,hid55,0);
}
static STATUS hid57(PRECC_DATA* self) {
PARSER hid56, p_nothing0;
return p_andparse0n (self,TOPARSER hid56,0,TOPARSER p_nothing0,0);
}
STATUS Ox(PRECC_DATA* self) {
PARSER hid57;
P_RETURN((TOPARSER hid57)(self),"Ox");
}
P_END

P_BEGIN
static STATUS hid58(PRECC_DATA* self) {
PARSER O, someoctdigits;
return p_andparse0n (self,TOPARSER O,0,TOPARSER someoctdigits,0);
}
static VOID hid59(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid60(PRECC_DATA* self) {
PARSER hid58;ACTION hid59;
return p_attach0n(self,TOPARSER hid58,0,hid59,0);
}
static STATUS hid61(PRECC_DATA* self) {
PARSER hid60, p_nothing0;
return p_andparse0n (self,TOPARSER hid60,0,TOPARSER p_nothing0,0);
}
STATUS OCTINT(PRECC_DATA* self) {
PARSER hid61;
P_RETURN((TOPARSER hid61)(self),"OCTINT");
}
P_END

P_BEGIN
static STATUS hid62(PRECC_DATA* self) {
return p_exactly0(self,'0');
}
static VOID hid63(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); ;
}
static STATUS hid64(PRECC_DATA* self) {
PARSER hid62;ACTION hid63;
return p_attach0n(self,TOPARSER hid62,0,hid63,0);
}
static STATUS hid65(PRECC_DATA* self) {
PARSER hid64, p_nothing0;
return p_andparse0n (self,TOPARSER hid64,0,TOPARSER p_nothing0,0);
}
STATUS O(PRECC_DATA* self) {
PARSER hid65;
P_RETURN((TOPARSER hid65)(self),"O");
}
P_END
P_BEGIN
static VOID hid66(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid67(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid66;
return p_attach0n(self,TOPARSER p_nothing0,0,hid66,0);
}
static STATUS hid68(PRECC_DATA* self) {
PARSER hid67, p_nothing0;
return p_andparse0n (self,TOPARSER hid67,0,TOPARSER p_nothing0,0);
}
static STATUS hid69 (PRECC_DATA* self) {
PARSER somedigits, hid68;
return p_orparse0n (self,TOPARSER somedigits,0,TOPARSER hid68,0);
}
STATUS digits(PRECC_DATA* self) {
PARSER hid69;
P_RETURN((TOPARSER hid69)(self),"digits");
}
P_END

P_BEGIN
static VOID hid70(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid71(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid70;
return p_attach0n(self,TOPARSER p_nothing0,0,hid70,0);
}
static STATUS hid72(PRECC_DATA* self) {
PARSER hid71, p_nothing0;
return p_andparse0n (self,TOPARSER hid71,0,TOPARSER p_nothing0,0);
}
static STATUS hid73 (PRECC_DATA* self) {
PARSER sign, hid72;
return p_orparse0n (self,TOPARSER sign,0,TOPARSER hid72,0);
}
STATUS optsign(PRECC_DATA* self) {
PARSER hid73;
P_RETURN((TOPARSER hid73)(self),"optsign");
}
P_END

P_BEGIN
static VOID hid74(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid75(PRECC_DATA* self) {
PARSER digit;ACTION hid74;
return p_attach0n(self,TOPARSER digit,0,hid74,0);
}
static STATUS hid76(PRECC_DATA* self) {
PARSER hid75, p_nothing0;
return p_andparse0n (self,TOPARSER hid75,0,TOPARSER p_nothing0,0);
}
static STATUS hid77(PRECC_DATA* self) {
PARSER hid76;
return p_many0n(self,TOPARSER hid76,0);
}
static STATUS hid78(PRECC_DATA* self) {
PARSER digit, hid77;
return p_andparse0n (self,TOPARSER digit,0,TOPARSER hid77,0);
}
STATUS somedigits(PRECC_DATA* self) {
PARSER hid78;
P_RETURN((TOPARSER hid78)(self),"somedigits");
}
P_END

P_BEGIN
static VOID hid79(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid80(PRECC_DATA* self) {
PARSER hexdigit;ACTION hid79;
return p_attach0n(self,TOPARSER hexdigit,0,hid79,0);
}
static STATUS hid81(PRECC_DATA* self) {
PARSER hid80, p_nothing0;
return p_andparse0n (self,TOPARSER hid80,0,TOPARSER p_nothing0,0);
}
static STATUS hid82(PRECC_DATA* self) {
PARSER hid81;
return p_many0n(self,TOPARSER hid81,0);
}
static STATUS hid83(PRECC_DATA* self) {
PARSER hexdigit, hid82;
return p_andparse0n (self,TOPARSER hexdigit,0,TOPARSER hid82,0);
}
STATUS somehexdigits(PRECC_DATA* self) {
PARSER hid83;
P_RETURN((TOPARSER hid83)(self),"somehexdigits");
}
P_END

P_BEGIN
static STATUS hid84(PRECC_DATA* self) {
PREDICATE p_ishexdig;
return p_range0n(self,p_ishexdig,0);
}
static VOID hid85(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid86(PRECC_DATA* self) {
PARSER hid84;ACTION hid85;
return p_attach0n(self,TOPARSER hid84,0,hid85,0);
}
static STATUS hid87(PRECC_DATA* self) {
PARSER hid86, p_nothing0;
return p_andparse0n (self,TOPARSER hid86,0,TOPARSER p_nothing0,0);
}
STATUS hexdigit(PRECC_DATA* self) {
PARSER hid87;
P_RETURN((TOPARSER hid87)(self),"hexdigit");
}
P_END

P_BEGIN
static STATUS hid88(PRECC_DATA* self) {
PREDICATE p_isoctdig;
return p_range0n(self,p_isoctdig,0);
}
static VOID hid89(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid90(PRECC_DATA* self) {
PARSER hid88;ACTION hid89;
return p_attach0n(self,TOPARSER hid88,0,hid89,0);
}
static STATUS hid91(PRECC_DATA* self) {
PARSER hid90, p_nothing0;
return p_andparse0n (self,TOPARSER hid90,0,TOPARSER p_nothing0,0);
}
STATUS octdigit(PRECC_DATA* self) {
PARSER hid91;
P_RETURN((TOPARSER hid91)(self),"octdigit");
}
P_END

P_BEGIN
static VOID hid92(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid93(PRECC_DATA* self) {
PARSER octdigit;ACTION hid92;
return p_attach0n(self,TOPARSER octdigit,0,hid92,0);
}
static STATUS hid94(PRECC_DATA* self) {
PARSER hid93, p_nothing0;
return p_andparse0n (self,TOPARSER hid93,0,TOPARSER p_nothing0,0);
}
static STATUS hid95(PRECC_DATA* self) {
PARSER hid94;
return p_many0n(self,TOPARSER hid94,0);
}
static STATUS hid96(PRECC_DATA* self) {
PARSER octdigit, hid95;
return p_andparse0n (self,TOPARSER octdigit,0,TOPARSER hid95,0);
}
STATUS someoctdigits(PRECC_DATA* self) {
PARSER hid96;
P_RETURN((TOPARSER hid96)(self),"someoctdigits");
}
P_END

P_BEGIN
static STATUS hid97(PRECC_DATA* self) {
return p_exactly0(self,'-');
}
static STATUS hid98(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
static STATUS hid99 (PRECC_DATA* self) {
PARSER hid97, hid98;
return p_orparse0n (self,TOPARSER hid97,0,TOPARSER hid98,0);
}
static VOID hid100(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid101(PRECC_DATA* self) {
PARSER hid99;ACTION hid100;
return p_attach0n(self,TOPARSER hid99,0,hid100,0);
}
static STATUS hid102(PRECC_DATA* self) {
PARSER hid101, p_nothing0;
return p_andparse0n (self,TOPARSER hid101,0,TOPARSER p_nothing0,0);
}
STATUS sign(PRECC_DATA* self) {
PARSER hid102;
P_RETURN((TOPARSER hid102)(self),"sign");
}
P_END

P_BEGIN
static VOID hid103(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid104(PRECC_DATA* self) {
PARSER somedigits;ACTION hid103;
return p_attach0n(self,TOPARSER somedigits,0,hid103,0);
}
static STATUS hid105(PRECC_DATA* self) {
PARSER hid104, p_nothing0;
return p_andparse0n (self,TOPARSER hid104,0,TOPARSER p_nothing0,0);
}
static STATUS hid106(PRECC_DATA* self) {
PARSER hid105;
return p_option0n(self,TOPARSER hid105,0);
}
static STATUS hid107(PRECC_DATA* self) {
PARSER point, hid106;
return p_andparse0n (self,TOPARSER point,0,TOPARSER hid106,0);
}
STATUS mantissa(PRECC_DATA* self) {
PARSER hid107;
P_RETURN((TOPARSER hid107)(self),"mantissa");
}
P_END

P_BEGIN
static STATUS hid108(PRECC_DATA* self) {
return p_exactly0(self,'.');
}
static VOID hid109(PRECC_DATA* self) {
 VV(1)=putchar('.'); 
}
static STATUS hid110(PRECC_DATA* self) {
PARSER hid108;ACTION hid109;
return p_attach0n(self,TOPARSER hid108,0,hid109,0);
}
static STATUS hid111(PRECC_DATA* self) {
PARSER hid110, p_nothing0;
return p_andparse0n (self,TOPARSER hid110,0,TOPARSER p_nothing0,0);
}
STATUS point(PRECC_DATA* self) {
PARSER hid111;
P_RETURN((TOPARSER hid111)(self),"point");
}
P_END

P_BEGIN
static STATUS hid112(PRECC_DATA* self) {
return p_exactly0(self,'e');
}
static STATUS hid113(PRECC_DATA* self) {
return p_exactly0(self,'E');
}
static STATUS hid114 (PRECC_DATA* self) {
PARSER hid112, hid113;
return p_orparse0n (self,TOPARSER hid112,0,TOPARSER hid113,0);
}
static VOID hid115(PRECC_DATA* self) {
 VV(1)=putchar(T(1)); 
}
static STATUS hid116(PRECC_DATA* self) {
PARSER hid114;ACTION hid115;
return p_attach0n(self,TOPARSER hid114,0,hid115,0);
}
static STATUS hid117(PRECC_DATA* self) {
PARSER hid116, p_nothing0;
return p_andparse0n (self,TOPARSER hid116,0,TOPARSER p_nothing0,0);
}
STATUS E(PRECC_DATA* self) {
PARSER hid117;
P_RETURN((TOPARSER hid117)(self),"E");
}
P_END

P_BEGIN
static STATUS hid118(PRECC_DATA* self) {
PARSER E, integer;
return p_andparse0n (self,TOPARSER E,0,TOPARSER integer,0);
}
static VOID hid119(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid120(PRECC_DATA* self) {
PARSER hid118;ACTION hid119;
return p_attach0n(self,TOPARSER hid118,0,hid119,0);
}
static STATUS hid121(PRECC_DATA* self) {
PARSER hid120, p_nothing0;
return p_andparse0n (self,TOPARSER hid120,0,TOPARSER p_nothing0,0);
}
STATUS exponent(PRECC_DATA* self) {
PARSER hid121;
P_RETURN((TOPARSER hid121)(self),"exponent");
}
P_END

P_BEGIN
static VOID hid122(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid123(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid122;
return p_attach0n(self,TOPARSER p_nothing0,0,hid122,0);
}
static STATUS hid124(PRECC_DATA* self) {
PARSER hid123, p_nothing0;
return p_andparse0n (self,TOPARSER hid123,0,TOPARSER p_nothing0,0);
}
static STATUS hid125 (PRECC_DATA* self) {
PARSER exponent, hid124;
return p_orparse0n (self,TOPARSER exponent,0,TOPARSER hid124,0);
}
STATUS optexponent(PRECC_DATA* self) {
PARSER hid125;
P_RETURN((TOPARSER hid125)(self),"optexponent");
}
P_END

P_BEGIN
static STATUS hid126(PRECC_DATA* self) {
return p_exactly0(self,'\'');
}
static VOID hid127(PRECC_DATA* self) {
 VV(1)=putchar('\''); 
}
static STATUS hid128(PRECC_DATA* self) {
PARSER hid126;ACTION hid127;
return p_attach0n(self,TOPARSER hid126,0,hid127,0);
}
static STATUS hid129(PRECC_DATA* self) {
PARSER hid128, p_nothing0;
return p_andparse0n (self,TOPARSER hid128,0,TOPARSER p_nothing0,0);
}
STATUS singlequote(PRECC_DATA* self) {
PARSER hid129;
P_RETURN((TOPARSER hid129)(self),"singlequote");
}
P_END

P_BEGIN
static STATUS hid130(PRECC_DATA* self) {
return p_exactly0(self,'\\');
}
STATUS escape(PRECC_DATA* self) {
PARSER hid130;
P_RETURN((TOPARSER hid130)(self),"escape");
}
P_END

P_BEGIN
STATUS ANYTHING(PRECC_DATA* self) {
PARSER p_anything0;
P_RETURN((TOPARSER p_anything0)(self),"ANYTHING");
}
P_END

P_BEGIN
static STATUS hid131(PRECC_DATA* self) {
return p_notexactly0(self,'\'');
}
STATUS notasinglequote(PRECC_DATA* self) {
PARSER hid131;
P_RETURN((TOPARSER hid131)(self),"notasinglequote");
}
P_END

P_BEGIN
static STATUS hid132(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid133(PRECC_DATA* self) {
 VV(2)=V(1);putchar('\\');putchar(T(2)); 
}
static STATUS hid134(PRECC_DATA* self) {
PARSER hid132;ACTION hid133;
return p_attach0n(self,TOPARSER hid132,0,hid133,0);
}
static STATUS hid135(PRECC_DATA* self) {
PARSER hid134, p_nothing0;
return p_andparse0n (self,TOPARSER hid134,0,TOPARSER p_nothing0,0);
}
static VOID hid136(PRECC_DATA* self) {
 VV(1)=putchar(T(1));
}
static STATUS hid137(PRECC_DATA* self) {
PARSER notasinglequote;ACTION hid136;
return p_attach0n(self,TOPARSER notasinglequote,0,hid136,0);
}
static STATUS hid138(PRECC_DATA* self) {
PARSER hid137, p_nothing0;
return p_andparse0n (self,TOPARSER hid137,0,TOPARSER p_nothing0,0);
}
static STATUS hid139 (PRECC_DATA* self) {
PARSER hid135, hid138;
return p_orparse0n (self,TOPARSER hid135,0,TOPARSER hid138,0);
}
STATUS chr(PRECC_DATA* self) {
PARSER hid139;
P_RETURN((TOPARSER hid139)(self),"chr");
}
P_END

P_BEGIN
static STATUS hid140(PRECC_DATA* self) {
PARSER chr, singlequote;
return p_andparse0n (self,TOPARSER chr,0,TOPARSER singlequote,0);
}
static STATUS hid141(PRECC_DATA* self) {
PARSER singlequote, hid140;
return p_andparse0n (self,TOPARSER singlequote,0,TOPARSER hid140,0);
}
static VOID hid142(PRECC_DATA* self) {
 VV(3)=V(1); 
}
static STATUS hid143(PRECC_DATA* self) {
PARSER hid141;ACTION hid142;
return p_attach0n(self,TOPARSER hid141,0,hid142,0);
}
static STATUS hid144(PRECC_DATA* self) {
PARSER hid143, p_nothing0;
return p_andparse0n (self,TOPARSER hid143,0,TOPARSER p_nothing0,0);
}
STATUS CHARCONST(PRECC_DATA* self) {
PARSER hid144;
P_RETURN((TOPARSER hid144)(self),"CHARCONST");
}
P_END

P_BEGIN
static STATUS hid145(PRECC_DATA* self) {
PARSER strchrs, doublequote;
return p_andparse0n (self,TOPARSER strchrs,0,TOPARSER doublequote,0);
}
static STATUS hid146(PRECC_DATA* self) {
PARSER doublequote, hid145;
return p_andparse0n (self,TOPARSER doublequote,0,TOPARSER hid145,0);
}
static VOID hid147(PRECC_DATA* self) {
 VV(3)=V(1); 
}
static STATUS hid148(PRECC_DATA* self) {
PARSER hid146;ACTION hid147;
return p_attach0n(self,TOPARSER hid146,0,hid147,0);
}
static STATUS hid149(PRECC_DATA* self) {
PARSER hid148, p_nothing0;
return p_andparse0n (self,TOPARSER hid148,0,TOPARSER p_nothing0,0);
}
STATUS STRING(PRECC_DATA* self) {
PARSER hid149;
P_RETURN((TOPARSER hid149)(self),"STRING");
}
P_END

P_BEGIN
static STATUS hid150(PRECC_DATA* self) {
return p_exactly0(self,'\"');
}
static VOID hid151(PRECC_DATA* self) {
 VV(1)=putchar('\"'); 
}
static STATUS hid152(PRECC_DATA* self) {
PARSER hid150;ACTION hid151;
return p_attach0n(self,TOPARSER hid150,0,hid151,0);
}
static STATUS hid153(PRECC_DATA* self) {
PARSER hid152, p_nothing0;
return p_andparse0n (self,TOPARSER hid152,0,TOPARSER p_nothing0,0);
}
STATUS doublequote(PRECC_DATA* self) {
PARSER hid153;
P_RETURN((TOPARSER hid153)(self),"doublequote");
}
P_END

P_BEGIN
static STATUS hid154(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid155(PRECC_DATA* self) {
 VV(2) = V(1);putchar('\\');putchar(T(2)); 
}
static STATUS hid156(PRECC_DATA* self) {
PARSER hid154;ACTION hid155;
return p_attach0n(self,TOPARSER hid154,0,hid155,0);
}
static STATUS hid157(PRECC_DATA* self) {
PARSER hid156, p_nothing0;
return p_andparse0n (self,TOPARSER hid156,0,TOPARSER p_nothing0,0);
}
static VOID hid158(PRECC_DATA* self) {
 VV(1) = putchar(T(1)); 
}
static STATUS hid159(PRECC_DATA* self) {
PARSER notadoublequote;ACTION hid158;
return p_attach0n(self,TOPARSER notadoublequote,0,hid158,0);
}
static STATUS hid160(PRECC_DATA* self) {
PARSER hid159, p_nothing0;
return p_andparse0n (self,TOPARSER hid159,0,TOPARSER p_nothing0,0);
}
static STATUS hid161 (PRECC_DATA* self) {
PARSER hid157, hid160;
return p_orparse0n (self,TOPARSER hid157,0,TOPARSER hid160,0);
}
STATUS strchar(PRECC_DATA* self) {
PARSER hid161;
P_RETURN((TOPARSER hid161)(self),"strchar");
}
P_END

P_BEGIN
static STATUS hid162(PRECC_DATA* self) {
return p_notexactly0(self,'\"');
}
STATUS notadoublequote(PRECC_DATA* self) {
PARSER hid162;
P_RETURN((TOPARSER hid162)(self),"notadoublequote");
}
P_END

P_BEGIN
static VOID hid163(PRECC_DATA* self) {
 VV(2)=V(1); 
}
static STATUS hid164(PRECC_DATA* self) {
PARSER strchar;ACTION hid163;
return p_attach0n(self,TOPARSER strchar,0,hid163,0);
}
static STATUS hid165(PRECC_DATA* self) {
PARSER hid164, p_nothing0;
return p_andparse0n (self,TOPARSER hid164,0,TOPARSER p_nothing0,0);
}
static STATUS hid166(PRECC_DATA* self) {
PARSER hid165;
return p_many0n(self,TOPARSER hid165,0);
}
static STATUS hid167(PRECC_DATA* self) {
PARSER strchar, hid166;
return p_andparse0n (self,TOPARSER strchar,0,TOPARSER hid166,0);
}
static VOID hid168(PRECC_DATA* self) {
 VV(0)=""; 
}
static STATUS hid169(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid168;
return p_attach0n(self,TOPARSER p_nothing0,0,hid168,0);
}
static STATUS hid170(PRECC_DATA* self) {
PARSER hid169, p_nothing0;
return p_andparse0n (self,TOPARSER hid169,0,TOPARSER p_nothing0,0);
}
static STATUS hid171 (PRECC_DATA* self) {
PARSER hid167, hid170;
return p_orparse0n (self,TOPARSER hid167,0,TOPARSER hid170,0);
}
STATUS strchrs(PRECC_DATA* self) {
PARSER hid171;
P_RETURN((TOPARSER hid171)(self),"strchrs");
}
P_END

P_BEGIN
static STATUS hid172(PRECC_DATA* self) {
return p_exactly0(self,'\\');
}
STATUS BACKSLASH(PRECC_DATA* self) {
PARSER hid172;
P_RETURN((TOPARSER hid172)(self),"BACKSLASH");
}
P_END

P_BEGIN
static STATUS hid173(PRECC_DATA* self) {
return p_exactly0(self,'$');
}
STATUS DOLLAR(PRECC_DATA* self) {
PARSER hid173;
P_RETURN((TOPARSER hid173)(self),"DOLLAR");
}
P_END

P_BEGIN
static STATUS hid174(PRECC_DATA* self) {
return p_exactly0(self,'^');
}
STATUS CARET(PRECC_DATA* self) {
PARSER hid174;
P_RETURN((TOPARSER hid174)(self),"CARET");
}
P_END

P_BEGIN
static STATUS hid175(PRECC_DATA* self) {
return p_exactly0(self,'!');
}
STATUS PLING(PRECC_DATA* self) {
PARSER hid175;
P_RETURN((TOPARSER hid175)(self),"PLING");
}
P_END

P_BEGIN
static STATUS hid176(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
STATUS PLUS(PRECC_DATA* self) {
PARSER hid176;
P_RETURN((TOPARSER hid176)(self),"PLUS");
}
P_END

P_BEGIN
static STATUS hid177(PRECC_DATA* self) {
return p_exactly0(self,'$');
}
static STATUS hid178(PRECC_DATA* self) {
return p_exactly0(self,'$');
}
static STATUS hid179(PRECC_DATA* self) {
PARSER hid177, hid178;
return p_andparse0n (self,TOPARSER hid177,0,TOPARSER hid178,0);
}
static VOID hid180(PRECC_DATA* self) {
VV(2)=putname("(TOVALUE p_1)");
}
static STATUS hid181(PRECC_DATA* self) {
PARSER hid179;ACTION hid180;
return p_attach0n(self,TOPARSER hid179,0,hid180,0);
}
static STATUS hid182(PRECC_DATA* self) {
PARSER hid181, p_nothing0;
return p_andparse0n (self,TOPARSER hid181,0,TOPARSER p_nothing0,0);
}
static STATUS hid183(PRECC_DATA* self) {
return p_exactly0(self,'$');
}
static VOID hid184(PRECC_DATA* self) {
putname("(TOVALUE p_");
                   /*putint((1+getcount())*PSTACKLENGTH/10); */
                    
}
static STATUS hid185(PRECC_DATA* self) {
PARSER hid183;ACTION hid184;
return p_attach0n(self,TOPARSER hid183,0,hid184,0);
}
static STATUS hid186(PRECC_DATA* self) {
PARSER hid185, p_nothing0;
return p_andparse0n (self,TOPARSER hid185,0,TOPARSER p_nothing0,0);
}
static STATUS hid187(PRECC_DATA* self) {
PARSER hid186, integer;
return p_andparse0n (self,TOPARSER hid186,0,TOPARSER integer,0);
}
static VOID hid188(PRECC_DATA* self) {
VV(2)=V(2);putchar(')');
}
static STATUS hid189(PRECC_DATA* self) {
PARSER hid187;ACTION hid188;
return p_attach0n(self,TOPARSER hid187,0,hid188,0);
}
static STATUS hid190(PRECC_DATA* self) {
PARSER hid189, p_nothing0;
return p_andparse0n (self,TOPARSER hid189,0,TOPARSER p_nothing0,0);
}
static STATUS hid191(PRECC_DATA* self) {
return p_exactly0(self,'$');
}
static VOID hid192(PRECC_DATA* self) {
putname("(TOVALUE ");
}
static STATUS hid193(PRECC_DATA* self) {
PARSER hid191;ACTION hid192;
return p_attach0n(self,TOPARSER hid191,0,hid192,0);
}
static STATUS hid194(PRECC_DATA* self) {
PARSER hid193, p_nothing0;
return p_andparse0n (self,TOPARSER hid193,0,TOPARSER p_nothing0,0);
}
static STATUS hid195(PRECC_DATA* self) {
PARSER hid194, IDENTIFIER;
return p_andparse0n (self,TOPARSER hid194,0,TOPARSER IDENTIFIER,0);
}
static VOID hid196(PRECC_DATA* self) {
VV(2)=putchar(')');
}
static STATUS hid197(PRECC_DATA* self) {
PARSER hid195;ACTION hid196;
return p_attach0n(self,TOPARSER hid195,0,hid196,0);
}
static STATUS hid198(PRECC_DATA* self) {
PARSER hid197, p_nothing0;
return p_andparse0n (self,TOPARSER hid197,0,TOPARSER p_nothing0,0);
}
static STATUS hid199 (PRECC_DATA* self) {
PARSER hid190, hid198;
return p_orparse0n (self,TOPARSER hid190,0,TOPARSER hid198,0);
}
static STATUS hid200 (PRECC_DATA* self) {
PARSER hid182, hid199;
return p_orparse0n (self,TOPARSER hid182,0,TOPARSER hid199,0);
}
STATUS DOLLARID(PRECC_DATA* self) {
PARSER hid200;
P_RETURN((TOPARSER hid200)(self),"DOLLARID");
}
P_END

P_BEGIN
static STATUS hid201(PRECC_DATA* self) {
PARSER optsign, somedigits;
return p_andparse0n (self,TOPARSER optsign,0,TOPARSER somedigits,0);
}
static VOID hid202(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid203(PRECC_DATA* self) {
PARSER hid201;ACTION hid202;
return p_attach0n(self,TOPARSER hid201,0,hid202,0);
}
static STATUS hid204(PRECC_DATA* self) {
PARSER hid203, p_nothing0;
return p_andparse0n (self,TOPARSER hid203,0,TOPARSER p_nothing0,0);
}
STATUS integer(PRECC_DATA* self) {
PARSER hid204;
P_RETURN((TOPARSER hid204)(self),"integer");
}
P_END

/* how did I come to miss . and ? and : originally? And what about -> ? */

P_BEGIN
static STATUS hid205(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
static STATUS hid206(PRECC_DATA* self) {
return p_exactly0(self,'-');
}
static STATUS hid207(PRECC_DATA* self) {
return p_exactly0(self,'*');
}
static STATUS hid208(PRECC_DATA* self) {
return p_exactly0(self,'/');
}
static STATUS hid209(PRECC_DATA* self) {
return p_exactly0(self,'%');
}
static STATUS hid210(PRECC_DATA* self) {
return p_exactly0(self,'&');
}
static STATUS hid211(PRECC_DATA* self) {
return p_exactly0(self,'|');
}
static STATUS hid212(PRECC_DATA* self) {
return p_exactly0(self,'!');
}
static STATUS hid213(PRECC_DATA* self) {
return p_exactly0(self,'=');
}
static STATUS hid214(PRECC_DATA* self) {
return p_exactly0(self,'<');
}
static STATUS hid215(PRECC_DATA* self) {
return p_exactly0(self,RIGHT_ANGLE_BRACKET);
}
static STATUS hid216(PRECC_DATA* self) {
return p_exactly0(self,'?');
}
static STATUS hid217(PRECC_DATA* self) {
return p_exactly0(self,':');
}
static STATUS hid218(PRECC_DATA* self) {
return p_exactly0(self,'.');
}
static STATUS hid219 (PRECC_DATA* self) {
PARSER hid217, hid218;
return p_orparse0n (self,TOPARSER hid217,0,TOPARSER hid218,0);
}
static STATUS hid220 (PRECC_DATA* self) {
PARSER hid216, hid219;
return p_orparse0n (self,TOPARSER hid216,0,TOPARSER hid219,0);
}
static STATUS hid221 (PRECC_DATA* self) {
PARSER hid215, hid220;
return p_orparse0n (self,TOPARSER hid215,0,TOPARSER hid220,0);
}
static STATUS hid222 (PRECC_DATA* self) {
PARSER hid214, hid221;
return p_orparse0n (self,TOPARSER hid214,0,TOPARSER hid221,0);
}
static STATUS hid223 (PRECC_DATA* self) {
PARSER hid213, hid222;
return p_orparse0n (self,TOPARSER hid213,0,TOPARSER hid222,0);
}
static STATUS hid224 (PRECC_DATA* self) {
PARSER hid212, hid223;
return p_orparse0n (self,TOPARSER hid212,0,TOPARSER hid223,0);
}
static STATUS hid225 (PRECC_DATA* self) {
PARSER hid211, hid224;
return p_orparse0n (self,TOPARSER hid211,0,TOPARSER hid224,0);
}
static STATUS hid226 (PRECC_DATA* self) {
PARSER hid210, hid225;
return p_orparse0n (self,TOPARSER hid210,0,TOPARSER hid225,0);
}
static STATUS hid227 (PRECC_DATA* self) {
PARSER hid209, hid226;
return p_orparse0n (self,TOPARSER hid209,0,TOPARSER hid226,0);
}
static STATUS hid228 (PRECC_DATA* self) {
PARSER hid208, hid227;
return p_orparse0n (self,TOPARSER hid208,0,TOPARSER hid227,0);
}
static STATUS hid229 (PRECC_DATA* self) {
PARSER hid207, hid228;
return p_orparse0n (self,TOPARSER hid207,0,TOPARSER hid228,0);
}
static STATUS hid230 (PRECC_DATA* self) {
PARSER hid206, hid229;
return p_orparse0n (self,TOPARSER hid206,0,TOPARSER hid229,0);
}
static STATUS hid231 (PRECC_DATA* self) {
PARSER hid205, hid230;
return p_orparse0n (self,TOPARSER hid205,0,TOPARSER hid230,0);
}
STATUS BINOPCHAR(PRECC_DATA* self) {
PARSER hid231;
P_RETURN((TOPARSER hid231)(self),"BINOPCHAR");
}
P_END

P_BEGIN
static STATUS hid232(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
static STATUS hid233(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
static STATUS hid234(PRECC_DATA* self) {
PARSER hid232, hid233;
return p_andparse0n (self,TOPARSER hid232,0,TOPARSER hid233,0);
}
static VOID hid235(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid236(PRECC_DATA* self) {
PARSER hid234;ACTION hid235;
return p_attach0n(self,TOPARSER hid234,0,hid235,0);
}
static STATUS hid237(PRECC_DATA* self) {
PARSER hid236, p_nothing0;
return p_andparse0n (self,TOPARSER hid236,0,TOPARSER p_nothing0,0);
}
STATUS PLUSPLUS(PRECC_DATA* self) {
PARSER hid237;
P_RETURN((TOPARSER hid237)(self),"PLUSPLUS");
}
P_END

P_BEGIN
static STATUS hid238(PRECC_DATA* self) {
return p_exactly0(self,'-');
}
static STATUS hid239(PRECC_DATA* self) {
return p_exactly0(self,'-');
}
static STATUS hid240(PRECC_DATA* self) {
PARSER hid238, hid239;
return p_andparse0n (self,TOPARSER hid238,0,TOPARSER hid239,0);
}
static VOID hid241(PRECC_DATA* self) {
 VV(2) = V(1); 
}
static STATUS hid242(PRECC_DATA* self) {
PARSER hid240;ACTION hid241;
return p_attach0n(self,TOPARSER hid240,0,hid241,0);
}
static STATUS hid243(PRECC_DATA* self) {
PARSER hid242, p_nothing0;
return p_andparse0n (self,TOPARSER hid242,0,TOPARSER p_nothing0,0);
}
STATUS MINUSMINUS(PRECC_DATA* self) {
PARSER hid243;
P_RETURN((TOPARSER hid243)(self),"MINUSMINUS");
}
P_END

P_BEGIN
static STATUS hid244(PRECC_DATA* self) {
return p_exactly0(self,'+');
}
static STATUS hid245(PRECC_DATA* self) {
return p_exactly0(self,'-');
}
static STATUS hid246(PRECC_DATA* self) {
return p_exactly0(self,'&');
}
static STATUS hid247(PRECC_DATA* self) {
return p_exactly0(self,'*');
}
static STATUS hid248(PRECC_DATA* self) {
return p_exactly0(self,'!');
}
static STATUS hid249 (PRECC_DATA* self) {
PARSER hid247, hid248;
return p_orparse0n (self,TOPARSER hid247,0,TOPARSER hid248,0);
}
static STATUS hid250 (PRECC_DATA* self) {
PARSER hid246, hid249;
return p_orparse0n (self,TOPARSER hid246,0,TOPARSER hid249,0);
}
static STATUS hid251 (PRECC_DATA* self) {
PARSER hid245, hid250;
return p_orparse0n (self,TOPARSER hid245,0,TOPARSER hid250,0);
}
static STATUS hid252 (PRECC_DATA* self) {
PARSER hid244, hid251;
return p_orparse0n (self,TOPARSER hid244,0,TOPARSER hid251,0);
}
STATUS MONOPCHAR(PRECC_DATA* self) {
PARSER hid252;
P_RETURN((TOPARSER hid252)(self),"MONOPCHAR");
}
P_END

P_BEGIN
static STATUS hid253(PRECC_DATA* self) {
return p_exactly0(self,'<');
}
STATUS LEFTANGLEBRACKET(PRECC_DATA* self) {
PARSER hid253;
P_RETURN((TOPARSER hid253)(self),"LEFTANGLEBRACKET");
}
P_END

P_BEGIN
static STATUS hid254(PRECC_DATA* self) {
return p_exactly0(self,RIGHT_ANGLE_BRACKET);
}
STATUS RIGHTANGLEBRACKET(PRECC_DATA* self) {
PARSER hid254;
P_RETURN((TOPARSER hid254)(self),"RIGHTANGLEBRACKET");
}
P_END

P_BEGIN
static STATUS hid255(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid256(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid257(PRECC_DATA* self) {
PARSER hid255;ACTION hid256;
return p_attach0n(self,TOPARSER hid255,0,hid256,0);
}
static STATUS hid258(PRECC_DATA* self) {
PARSER hid257, p_nothing0;
return p_andparse0n (self,TOPARSER hid257,0,TOPARSER p_nothing0,0);
}
static STATUS hid259(PRECC_DATA* self) {
return p_notexactly0(self,'>');
}
static STATUS hid260 (PRECC_DATA* self) {
PARSER hid258, hid259;
return p_orparse0n (self,TOPARSER hid258,0,TOPARSER hid259,0);
}
STATUS NOTARIGHTANGLEBRACKET(PRECC_DATA* self) {
PARSER hid260;
P_RETURN((TOPARSER hid260)(self),"NOTARIGHTANGLEBRACKET");
}
P_END

P_BEGIN
static STATUS hid261(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid262(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid263(PRECC_DATA* self) {
PARSER hid261;ACTION hid262;
return p_attach0n(self,TOPARSER hid261,0,hid262,0);
}
static STATUS hid264(PRECC_DATA* self) {
PARSER hid263, p_nothing0;
return p_andparse0n (self,TOPARSER hid263,0,TOPARSER p_nothing0,0);
}
static STATUS hid265(PRECC_DATA* self) {
return p_notexactly0(self,LEFT_ANGLE_BRACKET);
}
static STATUS hid266 (PRECC_DATA* self) {
PARSER hid264, hid265;
return p_orparse0n (self,TOPARSER hid264,0,TOPARSER hid265,0);
}
STATUS NOTALEFTANGLEBRACKET(PRECC_DATA* self) {
PARSER hid266;
P_RETURN((TOPARSER hid266)(self),"NOTALEFTANGLEBRACKET");
}
P_END

P_BEGIN
static STATUS hid267(PRECC_DATA* self) {
return p_exactly0(self,'/');
}
STATUS SLASH(PRECC_DATA* self) {
PARSER hid267;
P_RETURN((TOPARSER hid267)(self),"SLASH");
}
P_END

P_BEGIN
static STATUS hid268(PRECC_DATA* self) {
return p_exactly0(self,'*');
}
STATUS STAR(PRECC_DATA* self) {
PARSER hid268;
P_RETURN((TOPARSER hid268)(self),"STAR");
}
P_END

P_BEGIN
static STATUS hid269(PRECC_DATA* self) {
return p_exactly0(self,'@');
}
STATUS AT(PRECC_DATA* self) {
PARSER hid269;
P_RETURN((TOPARSER hid269)(self),"AT");
}
P_END

P_BEGIN
static STATUS hid270(PRECC_DATA* self) {
return p_exactly0(self,'=');
}
STATUS EQUALS(PRECC_DATA* self) {
PARSER hid270;
P_RETURN((TOPARSER hid270)(self),"EQUALS");
}
P_END

P_BEGIN
static STATUS hid271(PRECC_DATA* self) {
return p_notexactly0(self,'@');
}
STATUS NOTANAT(PRECC_DATA* self) {
PARSER hid271;
P_RETURN((TOPARSER hid271)(self),"NOTANAT");
}
P_END

P_BEGIN
static STATUS hid272(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid273(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid274(PRECC_DATA* self) {
PARSER hid272;ACTION hid273;
return p_attach0n(self,TOPARSER hid272,0,hid273,0);
}
static STATUS hid275(PRECC_DATA* self) {
PARSER hid274, p_nothing0;
return p_andparse0n (self,TOPARSER hid274,0,TOPARSER p_nothing0,0);
}
static STATUS hid276(PRECC_DATA* self) {
return p_exactly0(self,'@');
}
static STATUS hid277(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid278(PRECC_DATA* self) {
PARSER hid276, hid277;
return p_andparse0n (self,TOPARSER hid276,0,TOPARSER hid277,0);
}
static VOID hid279(PRECC_DATA* self) {
VV(2)=(putchar('@'),V(2));
}
static STATUS hid280(PRECC_DATA* self) {
PARSER hid278;ACTION hid279;
return p_attach0n(self,TOPARSER hid278,0,hid279,0);
}
static STATUS hid281(PRECC_DATA* self) {
PARSER hid280, p_nothing0;
return p_andparse0n (self,TOPARSER hid280,0,TOPARSER p_nothing0,0);
}
static STATUS hid282(PRECC_DATA* self) {
return p_notexactly0(self,'@');
}
static STATUS hid283 (PRECC_DATA* self) {
PARSER hid281, hid282;
return p_orparse0n (self,TOPARSER hid281,0,TOPARSER hid282,0);
}
static STATUS hid284 (PRECC_DATA* self) {
PARSER hid275, hid283;
return p_orparse0n (self,TOPARSER hid275,0,TOPARSER hid283,0);
}
STATUS NOTANATBRACE(PRECC_DATA* self) {
PARSER hid284;
P_RETURN((TOPARSER hid284)(self),"NOTANATBRACE");
}
P_END

P_BEGIN
static STATUS hid285(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid286(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid287(PRECC_DATA* self) {
PARSER hid285;ACTION hid286;
return p_attach0n(self,TOPARSER hid285,0,hid286,0);
}
static STATUS hid288(PRECC_DATA* self) {
PARSER hid287, p_nothing0;
return p_andparse0n (self,TOPARSER hid287,0,TOPARSER p_nothing0,0);
}
static STATUS hid289(PRECC_DATA* self) {
return p_exactly0(self,'}');
}
static STATUS hid290(PRECC_DATA* self) {
return p_notexactly0(self,'@');
}
static STATUS hid291(PRECC_DATA* self) {
PARSER hid289, hid290;
return p_andparse0n (self,TOPARSER hid289,0,TOPARSER hid290,0);
}
static VOID hid292(PRECC_DATA* self) {
VV(2)=(putchar('@'),V(2));
}
static STATUS hid293(PRECC_DATA* self) {
PARSER hid291;ACTION hid292;
return p_attach0n(self,TOPARSER hid291,0,hid292,0);
}
static STATUS hid294(PRECC_DATA* self) {
PARSER hid293, p_nothing0;
return p_andparse0n (self,TOPARSER hid293,0,TOPARSER p_nothing0,0);
}
static STATUS hid295(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid296 (PRECC_DATA* self) {
PARSER hid294, hid295;
return p_orparse0n (self,TOPARSER hid294,0,TOPARSER hid295,0);
}
static STATUS hid297 (PRECC_DATA* self) {
PARSER hid288, hid296;
return p_orparse0n (self,TOPARSER hid288,0,TOPARSER hid296,0);
}
STATUS NOTABRACEAT(PRECC_DATA* self) {
PARSER hid297;
P_RETURN((TOPARSER hid297)(self),"NOTABRACEAT");
}
P_END

P_BEGIN
static STATUS hid298(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid299(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid300(PRECC_DATA* self) {
PARSER hid298;ACTION hid299;
return p_attach0n(self,TOPARSER hid298,0,hid299,0);
}
static STATUS hid301(PRECC_DATA* self) {
PARSER hid300, p_nothing0;
return p_andparse0n (self,TOPARSER hid300,0,TOPARSER p_nothing0,0);
}
static STATUS hid302(PRECC_DATA* self) {
return p_exactly0(self,'(');
}
static STATUS hid303(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid304(PRECC_DATA* self) {
PARSER hid302, hid303;
return p_andparse0n (self,TOPARSER hid302,0,TOPARSER hid303,0);
}
static VOID hid305(PRECC_DATA* self) {
VV(2)=(putchar('('),V(2));
}
static STATUS hid306(PRECC_DATA* self) {
PARSER hid304;ACTION hid305;
return p_attach0n(self,TOPARSER hid304,0,hid305,0);
}
static STATUS hid307(PRECC_DATA* self) {
PARSER hid306, p_nothing0;
return p_andparse0n (self,TOPARSER hid306,0,TOPARSER p_nothing0,0);
}
static STATUS hid308(PRECC_DATA* self) {
return p_notexactly0(self,'(');
}
static STATUS hid309 (PRECC_DATA* self) {
PARSER hid307, hid308;
return p_orparse0n (self,TOPARSER hid307,0,TOPARSER hid308,0);
}
static STATUS hid310 (PRECC_DATA* self) {
PARSER hid301, hid309;
return p_orparse0n (self,TOPARSER hid301,0,TOPARSER hid309,0);
}
STATUS NOTANOPENPARBRACE(PRECC_DATA* self) {
PARSER hid310;
P_RETURN((TOPARSER hid310)(self),"NOTANOPENPARBRACE");
}
P_END

P_BEGIN
static STATUS hid311(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid312(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid313(PRECC_DATA* self) {
PARSER hid311;ACTION hid312;
return p_attach0n(self,TOPARSER hid311,0,hid312,0);
}
static STATUS hid314(PRECC_DATA* self) {
PARSER hid313, p_nothing0;
return p_andparse0n (self,TOPARSER hid313,0,TOPARSER p_nothing0,0);
}
static STATUS hid315(PRECC_DATA* self) {
return p_exactly0(self,'}');
}
static STATUS hid316(PRECC_DATA* self) {
return p_notexactly0(self,'(');
}
static STATUS hid317(PRECC_DATA* self) {
PARSER hid315, hid316;
return p_andparse0n (self,TOPARSER hid315,0,TOPARSER hid316,0);
}
static VOID hid318(PRECC_DATA* self) {
VV(2)=(putchar('('),V(2));
}
static STATUS hid319(PRECC_DATA* self) {
PARSER hid317;ACTION hid318;
return p_attach0n(self,TOPARSER hid317,0,hid318,0);
}
static STATUS hid320(PRECC_DATA* self) {
PARSER hid319, p_nothing0;
return p_andparse0n (self,TOPARSER hid319,0,TOPARSER p_nothing0,0);
}
static STATUS hid321(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid322 (PRECC_DATA* self) {
PARSER hid320, hid321;
return p_orparse0n (self,TOPARSER hid320,0,TOPARSER hid321,0);
}
static STATUS hid323 (PRECC_DATA* self) {
PARSER hid314, hid322;
return p_orparse0n (self,TOPARSER hid314,0,TOPARSER hid322,0);
}
STATUS NOTABRACEOPENPAR(PRECC_DATA* self) {
PARSER hid323;
P_RETURN((TOPARSER hid323)(self),"NOTABRACEOPENPAR");
}
P_END

P_BEGIN
static STATUS hid324(PRECC_DATA* self) {
return p_exactly0(self,'|');
}
STATUS OR(PRECC_DATA* self) {
PARSER hid324;
P_RETURN((TOPARSER hid324)(self),"OR");
}
P_END

P_BEGIN
static STATUS hid325(PRECC_DATA* self) {
return p_exactly0(self,':');
}
STATUS COLON(PRECC_DATA* self) {
PARSER hid325;
P_RETURN((TOPARSER hid325)(self),"COLON");
}
P_END

P_BEGIN
static STATUS hid326 (PRECC_DATA* self) {
PARSER COLON, p_last0;
return p_orparse0n (self,TOPARSER COLON,0,TOPARSER p_last0,0);
}
STATUS COLONorEOL(PRECC_DATA* self) {
PARSER hid326;
P_RETURN((TOPARSER hid326)(self),"COLONorEOL");
}
P_END

P_BEGIN
static STATUS hid327(PRECC_DATA* self) {
return p_exactly0(self,',');
}
STATUS COMMA(PRECC_DATA* self) {
PARSER hid327;
P_RETURN((TOPARSER hid327)(self),"COMMA");
}
P_END

P_BEGIN
static STATUS hid328(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid329(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid330(PRECC_DATA* self) {
PARSER hid328;ACTION hid329;
return p_attach0n(self,TOPARSER hid328,0,hid329,0);
}
static STATUS hid331(PRECC_DATA* self) {
PARSER hid330, p_nothing0;
return p_andparse0n (self,TOPARSER hid330,0,TOPARSER p_nothing0,0);
}
static STATUS hid332(PRECC_DATA* self) {
return p_notexactly0(self,':');
}
static STATUS hid333 (PRECC_DATA* self) {
PARSER hid331, hid332;
return p_orparse0n (self,TOPARSER hid331,0,TOPARSER hid332,0);
}
STATUS NOTACOLON(PRECC_DATA* self) {
PARSER hid333;
P_RETURN((TOPARSER hid333)(self),"NOTACOLON");
}
P_END

P_BEGIN
static STATUS hid334(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid335(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid336(PRECC_DATA* self) {
PARSER hid334;ACTION hid335;
return p_attach0n(self,TOPARSER hid334,0,hid335,0);
}
static STATUS hid337(PRECC_DATA* self) {
PARSER hid336, p_nothing0;
return p_andparse0n (self,TOPARSER hid336,0,TOPARSER p_nothing0,0);
}
static STATUS hid338(PRECC_DATA* self) {
return p_exactly0(self,':');
}
static STATUS hid339(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid340(PRECC_DATA* self) {
PARSER hid338, hid339;
return p_andparse0n (self,TOPARSER hid338,0,TOPARSER hid339,0);
}
static VOID hid341(PRECC_DATA* self) {
VV(2)=(putchar(':'),V(2));
}
static STATUS hid342(PRECC_DATA* self) {
PARSER hid340;ACTION hid341;
return p_attach0n(self,TOPARSER hid340,0,hid341,0);
}
static STATUS hid343(PRECC_DATA* self) {
PARSER hid342, p_nothing0;
return p_andparse0n (self,TOPARSER hid342,0,TOPARSER p_nothing0,0);
}
static STATUS hid344(PRECC_DATA* self) {
return p_notexactly0(self,':');
}
static STATUS hid345 (PRECC_DATA* self) {
PARSER hid343, hid344;
return p_orparse0n (self,TOPARSER hid343,0,TOPARSER hid344,0);
}
static STATUS hid346 (PRECC_DATA* self) {
PARSER hid337, hid345;
return p_orparse0n (self,TOPARSER hid337,0,TOPARSER hid345,0);
}
STATUS NOTACOLONBRACE(PRECC_DATA* self) {
PARSER hid346;
P_RETURN((TOPARSER hid346)(self),"NOTACOLONBRACE");
}
P_END

P_BEGIN
static STATUS hid347(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid348(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid349(PRECC_DATA* self) {
PARSER hid347;ACTION hid348;
return p_attach0n(self,TOPARSER hid347,0,hid348,0);
}
static STATUS hid350(PRECC_DATA* self) {
PARSER hid349, p_nothing0;
return p_andparse0n (self,TOPARSER hid349,0,TOPARSER p_nothing0,0);
}
static STATUS hid351(PRECC_DATA* self) {
return p_exactly0(self,'}');
}
static STATUS hid352(PRECC_DATA* self) {
return p_notexactly0(self,':');
}
static STATUS hid353(PRECC_DATA* self) {
PARSER hid351, hid352;
return p_andparse0n (self,TOPARSER hid351,0,TOPARSER hid352,0);
}
static VOID hid354(PRECC_DATA* self) {
VV(2)=(putchar(':'),V(2));
}
static STATUS hid355(PRECC_DATA* self) {
PARSER hid353;ACTION hid354;
return p_attach0n(self,TOPARSER hid353,0,hid354,0);
}
static STATUS hid356(PRECC_DATA* self) {
PARSER hid355, p_nothing0;
return p_andparse0n (self,TOPARSER hid355,0,TOPARSER p_nothing0,0);
}
static STATUS hid357(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid358 (PRECC_DATA* self) {
PARSER hid356, hid357;
return p_orparse0n (self,TOPARSER hid356,0,TOPARSER hid357,0);
}
static STATUS hid359 (PRECC_DATA* self) {
PARSER hid350, hid358;
return p_orparse0n (self,TOPARSER hid350,0,TOPARSER hid358,0);
}
STATUS NOTABRACECOLON(PRECC_DATA* self) {
PARSER hid359;
P_RETURN((TOPARSER hid359)(self),"NOTABRACECOLON");
}
P_END

P_BEGIN
static STATUS hid360(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid361(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid362(PRECC_DATA* self) {
PARSER hid360;ACTION hid361;
return p_attach0n(self,TOPARSER hid360,0,hid361,0);
}
static STATUS hid363(PRECC_DATA* self) {
PARSER hid362, p_nothing0;
return p_andparse0n (self,TOPARSER hid362,0,TOPARSER p_nothing0,0);
}
static STATUS hid364(PRECC_DATA* self) {
return p_notexactly0(self,'}');
}
static STATUS hid365 (PRECC_DATA* self) {
PARSER hid363, hid364;
return p_orparse0n (self,TOPARSER hid363,0,TOPARSER hid364,0);
}
STATUS NOTACLOSEBRACE(PRECC_DATA* self) {
PARSER hid365;
P_RETURN((TOPARSER hid365)(self),"NOTACLOSEBRACE");
}
P_END

P_BEGIN
static STATUS hid366(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid367(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid368(PRECC_DATA* self) {
PARSER hid366;ACTION hid367;
return p_attach0n(self,TOPARSER hid366,0,hid367,0);
}
static STATUS hid369(PRECC_DATA* self) {
PARSER hid368, p_nothing0;
return p_andparse0n (self,TOPARSER hid368,0,TOPARSER p_nothing0,0);
}
static STATUS hid370(PRECC_DATA* self) {
return p_notexactly0(self,')');
}
static STATUS hid371 (PRECC_DATA* self) {
PARSER hid369, hid370;
return p_orparse0n (self,TOPARSER hid369,0,TOPARSER hid370,0);
}
STATUS NOTACLOSEPAREN(PRECC_DATA* self) {
PARSER hid371;
P_RETURN((TOPARSER hid371)(self),"NOTACLOSEPAREN");
}
P_END

P_BEGIN
static STATUS hid372(PRECC_DATA* self) {
PARSER escape, ANYTHING;
return p_andparse0n (self,TOPARSER escape,0,TOPARSER ANYTHING,0);
}
static VOID hid373(PRECC_DATA* self) {
VV(2)=V(2);
}
static STATUS hid374(PRECC_DATA* self) {
PARSER hid372;ACTION hid373;
return p_attach0n(self,TOPARSER hid372,0,hid373,0);
}
static STATUS hid375(PRECC_DATA* self) {
PARSER hid374, p_nothing0;
return p_andparse0n (self,TOPARSER hid374,0,TOPARSER p_nothing0,0);
}
static STATUS hid376(PRECC_DATA* self) {
return p_notexactly0(self,']');
}
static STATUS hid377 (PRECC_DATA* self) {
PARSER hid375, hid376;
return p_orparse0n (self,TOPARSER hid375,0,TOPARSER hid376,0);
}
STATUS NOTACLOSESQBRKT(PRECC_DATA* self) {
PARSER hid377;
P_RETURN((TOPARSER hid377)(self),"NOTACLOSESQBRKT");
}
P_END

P_BEGIN
static STATUS hid378(PRECC_DATA* self) {
return p_exactly0(self,'?');
}
STATUS QUESTION(PRECC_DATA* self) {
PARSER hid378;
P_RETURN((TOPARSER hid378)(self),"QUESTION");
}
P_END

P_BEGIN
static STATUS hid379(PRECC_DATA* self) {
PARSER SLASH, STAR;
return p_andparse0n (self,TOPARSER SLASH,0,TOPARSER STAR,0);
}
static VOID hid380(PRECC_DATA* self) {
VV(2)=putname("/*");
}
static STATUS hid381(PRECC_DATA* self) {
PARSER hid379;ACTION hid380;
return p_attach0n(self,TOPARSER hid379,0,hid380,0);
}
static STATUS hid382(PRECC_DATA* self) {
PARSER hid381, p_nothing0;
return p_andparse0n (self,TOPARSER hid381,0,TOPARSER p_nothing0,0);
}
STATUS slashstar(PRECC_DATA* self) {
PARSER hid382;
P_RETURN((TOPARSER hid382)(self),"slashstar");
}
P_END

P_BEGIN
static STATUS hid383(PRECC_DATA* self) {
PARSER STAR, SLASH;
return p_andparse0n (self,TOPARSER STAR,0,TOPARSER SLASH,0);
}
static VOID hid384(PRECC_DATA* self) {
VV(2)=putname("*/");
}
static STATUS hid385(PRECC_DATA* self) {
PARSER hid383;ACTION hid384;
return p_attach0n(self,TOPARSER hid383,0,hid384,0);
}
static STATUS hid386(PRECC_DATA* self) {
PARSER hid385, p_nothing0;
return p_andparse0n (self,TOPARSER hid385,0,TOPARSER p_nothing0,0);
}
STATUS starslash(PRECC_DATA* self) {
PARSER hid386;
P_RETURN((TOPARSER hid386)(self),"starslash");
}
P_END

P_BEGIN
static VOID hid387(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid388(PRECC_DATA* self) {
PARSER commentchr;ACTION hid387;
return p_attach0n(self,TOPARSER commentchr,0,hid387,0);
}
static STATUS hid389(PRECC_DATA* self) {
PARSER hid388, p_nothing0;
return p_andparse0n (self,TOPARSER hid388,0,TOPARSER p_nothing0,0);
}
static STATUS hid390(PRECC_DATA* self) {
PARSER hid389;
return p_many0n(self,TOPARSER hid389,0);
}
static STATUS hid391(PRECC_DATA* self) {
PARSER hid390, starslash;
return p_andparse0n (self,TOPARSER hid390,0,TOPARSER starslash,0);
}
static STATUS hid392(PRECC_DATA* self) {
PARSER slashstar, hid391;
return p_andparse0n (self,TOPARSER slashstar,0,TOPARSER hid391,0);
}
static VOID hid393(PRECC_DATA* self) {
VV(2)=V(1);
}
static STATUS hid394(PRECC_DATA* self) {
PARSER hid392;ACTION hid393;
return p_attach0n(self,TOPARSER hid392,0,hid393,0);
}
static STATUS hid395(PRECC_DATA* self) {
PARSER hid394, p_nothing0;
return p_andparse0n (self,TOPARSER hid394,0,TOPARSER p_nothing0,0);
}
STATUS COMMENT(PRECC_DATA* self) {
PARSER hid395;
P_RETURN((TOPARSER hid395)(self),"COMMENT");
}
P_END

/* $!{foo} ought to try and recover at foo */

P_BEGIN
static VOID hid396(PRECC_DATA* self) {
 VV(1) = putchar(T(1));
}
static STATUS hid397(PRECC_DATA* self) {
PARSER NOTASTAR;ACTION hid396;
return p_attach0n(self,TOPARSER NOTASTAR,0,hid396,0);
}
static STATUS hid398(PRECC_DATA* self) {
PARSER hid397, p_nothing0;
return p_andparse0n (self,TOPARSER hid397,0,TOPARSER p_nothing0,0);
}
static VOID hid399(PRECC_DATA* self) {
 VV(1) = putchar('\n');
}
static STATUS hid400(PRECC_DATA* self) {
PARSER p_lastuniq0;ACTION hid399;
return p_attach0n(self,TOPARSER p_lastuniq0,0,hid399,0);
}
static STATUS hid401(PRECC_DATA* self) {
PARSER hid400, p_nothing0;
return p_andparse0n (self,TOPARSER hid400,0,TOPARSER p_nothing0,0);
}
static STATUS hid402(PRECC_DATA* self) {
PARSER STAR, NOTASLASH;
return p_andparse0n (self,TOPARSER STAR,0,TOPARSER NOTASLASH,0);
}
static VOID hid403(PRECC_DATA* self) {
 VV(2) = (putchar('*'),putchar(T(2)));
}
static STATUS hid404(PRECC_DATA* self) {
PARSER hid402;ACTION hid403;
return p_attach0n(self,TOPARSER hid402,0,hid403,0);
}
static STATUS hid405(PRECC_DATA* self) {
PARSER hid404, p_nothing0;
return p_andparse0n (self,TOPARSER hid404,0,TOPARSER p_nothing0,0);
}
static STATUS hid406 (PRECC_DATA* self) {
PARSER hid401, hid405;
return p_orparse0n (self,TOPARSER hid401,0,TOPARSER hid405,0);
}
static STATUS hid407 (PRECC_DATA* self) {
PARSER hid398, hid406;
return p_orparse0n (self,TOPARSER hid398,0,TOPARSER hid406,0);
}
STATUS commentchr(PRECC_DATA* self) {
PARSER hid407;
P_RETURN((TOPARSER hid407)(self),"commentchr");
}
P_END

P_BEGIN
static STATUS hid408(PRECC_DATA* self) {
return p_notexactly0(self,'*');
}
STATUS NOTASTAR(PRECC_DATA* self) {
PARSER hid408;
P_RETURN((TOPARSER hid408)(self),"NOTASTAR");
}
P_END

P_BEGIN
static STATUS hid409(PRECC_DATA* self) {
return p_notexactly0(self,'/');
}
STATUS NOTASLASH(PRECC_DATA* self) {
PARSER hid409;
P_RETURN((TOPARSER hid409)(self),"NOTASLASH");
}
P_END

P_BEGIN
static STATUS hid410(PRECC_DATA* self) {
return p_exactly0(self,';');
}
STATUS SEMICOLON(PRECC_DATA* self) {
PARSER hid410;
P_RETURN((TOPARSER hid410)(self),"SEMICOLON");
}
P_END

P_BEGIN
static STATUS hid411(PRECC_DATA* self) {
return p_exactly0(self,'.');
}
static STATUS hid412(PRECC_DATA* self) {
return p_exactly0(self,'.');
}
static STATUS hid413(PRECC_DATA* self) {
return p_exactly0(self,'.');
}
static STATUS hid414(PRECC_DATA* self) {
PARSER hid412, hid413;
return p_andparse0n (self,TOPARSER hid412,0,TOPARSER hid413,0);
}
static STATUS hid415(PRECC_DATA* self) {
PARSER hid411, hid414;
return p_andparse0n (self,TOPARSER hid411,0,TOPARSER hid414,0);
}
static VOID hid416(PRECC_DATA* self) {
 VV(3) = V(1);
}
static STATUS hid417(PRECC_DATA* self) {
PARSER hid415;ACTION hid416;
return p_attach0n(self,TOPARSER hid415,0,hid416,0);
}
static STATUS hid418(PRECC_DATA* self) {
PARSER hid417, p_nothing0;
return p_andparse0n (self,TOPARSER hid417,0,TOPARSER p_nothing0,0);
}
STATUS ELLIPSIS(PRECC_DATA* self) {
PARSER hid418;
P_RETURN((TOPARSER hid418)(self),"ELLIPSIS");
}
P_END

P_BEGIN
static STATUS hid419(PRECC_DATA* self) {
return p_exactly0(self,'N');
}
static STATUS hid420(PRECC_DATA* self) {
return p_exactly0(self,'E');
}
static STATUS hid421(PRECC_DATA* self) {
return p_exactly0(self,'W');
}
static STATUS hid422(PRECC_DATA* self) {
PARSER hid420, hid421;
return p_andparse0n (self,TOPARSER hid420,0,TOPARSER hid421,0);
}
static STATUS hid423(PRECC_DATA* self) {
PARSER hid419, hid422;
return p_andparse0n (self,TOPARSER hid419,0,TOPARSER hid422,0);
}
static VOID hid424(PRECC_DATA* self) {
 VV(3) = V(1);
}
static STATUS hid425(PRECC_DATA* self) {
PARSER hid423;ACTION hid424;
return p_attach0n(self,TOPARSER hid423,0,hid424,0);
}
static STATUS hid426(PRECC_DATA* self) {
PARSER hid425, p_nothing0;
return p_andparse0n (self,TOPARSER hid425,0,TOPARSER p_nothing0,0);
}
STATUS NEW(PRECC_DATA* self) {
PARSER hid426;
P_RETURN((TOPARSER hid426)(self),"NEW");
}
P_END

/*   finis   */


