# define BEGIN begin(p_argc,p_argv)
# define DEBUG
# define PARAM char*
/*# define VALUE char**/
# include "ccx.h"


int begin(int argc,char **argv)
{
        static int passes; /* no. of times re-entered MAIN */

        if(passes++==0)
        {
            dup2(0,5);  /* save stdin and stdout */
            dup2(1,6);
            switch(argc)
            {
            case 3:
                    if (freopen(argv[2], "w", stdout)==NULL)
                      exit (2);
            case 2:
                    if (freopen(argv[1], "r", stdin)==NULL)
                      exit (5);
            case 1: break;
            default: exit(6);/* too many files named */
            }
        }
        return 0;                /* success */
}

P_BEGIN
static STATUS hid0(PRECC_DATA* self) {
PARSER ws;
return p_many0n(self,TOPARSER ws,0);
}
static STATUS hid1(PRECC_DATA* self) {
PARSER Paragraph, p_uniq0;
return p_andparse0n (self,TOPARSER Paragraph,0,TOPARSER p_uniq0,0);
}
static STATUS hid2(PRECC_DATA* self) {
PARSER hid1;
return p_many0n(self,TOPARSER hid1,0);
}
static STATUS hid3(PRECC_DATA* self) {
PARSER hid0, hid2;
return p_andparse0n (self,TOPARSER hid0,0,TOPARSER hid2,0);
}
STATUS Specification(PRECC_DATA* self) {
PARSER hid3;
P_RETURN((TOPARSER hid3)(self),"Specification");
}
P_END

P_BEGIN
static STATUS hid4 (PRECC_DATA* self) {
PARSER Directive, Comment;
return p_orparse0n (self,TOPARSER Directive,0,TOPARSER Comment,0);
}
static STATUS hid5 (PRECC_DATA* self) {
PARSER Generic_Box, hid4;
return p_orparse0n (self,TOPARSER Generic_Box,0,TOPARSER hid4,0);
}
static STATUS hid6 (PRECC_DATA* self) {
PARSER Schema_Box, hid5;
return p_orparse0n (self,TOPARSER Schema_Box,0,TOPARSER hid5,0);
}
static STATUS hid7 (PRECC_DATA* self) {
PARSER Axiomatic_Box, hid6;
return p_orparse0n (self,TOPARSER Axiomatic_Box,0,TOPARSER hid6,0);
}
static STATUS hid8 (PRECC_DATA* self) {
PARSER Unboxed_Para, hid7;
return p_orparse0n (self,TOPARSER Unboxed_Para,0,TOPARSER hid7,0);
}
STATUS Paragraph(PRECC_DATA* self) {
PARSER hid8;
P_RETURN((TOPARSER hid8)(self),"Paragraph");
}
P_END

static int nsymbol;         /* local buffer for symbols in directives */
static int symbol[32];

extern void         add_inops  (int *ss, int sn, int p);
extern void         add_postops(int *ss, int sn);
extern void         add_inrels (int *ss, int sn);
extern void         add_prerels(int *ss, int sn);
extern void         add_ingens(int *ss, int sn);
extern void         add_pregens(int *ss, int sn);
extern void         add_ignores(int *ss, int sn);
extern void         add_tokens(int *ss, int sn);

P_BEGIN
static VOID hid9(PRECC_DATA* self,VALUE p) {
 add_inops(symbol,nsymbol,(int)(TOVALUE p)); 
}
static STATUS hid10(PRECC_DATA* self,VALUE p) {
PARSER p_nothing0;ACTION hid9;
return p_attach0n(self,TOPARSER p_nothing0,0,hid9,P_SZ(1,1),p);
}
static STATUS hid11(PRECC_DATA* self,VALUE p) {
PARSER hid10, p_uniq0;
return p_andparse0n (self,TOPARSER hid10,P_SZ(1,1),p,TOPARSER p_uniq0,0);
}
static STATUS hid12(PRECC_DATA* self,VALUE p) {
PARSER L_ENDLINE, hid11;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid11,P_SZ(1,1),p);
}
static STATUS hid13(PRECC_DATA* self) {
PARSER Priority, hid12; VALUE p;
static STATUS p_tok;
P_PSTAR(p,(TOPARSER Priority)(self),(TOPARSER hid12)(self,p));
return p_tok;
}
static STATUS hid14(PRECC_DATA* self) {
PARSER Symbols, hid13;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid13,0);
}
static STATUS hid15(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_INOP, hid14;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_INOP,0,TOPARSER hid14,0);
}
static VOID hid16(PRECC_DATA* self) {
 add_postops(symbol,nsymbol); 
}
static STATUS hid17(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid16;
return p_attach0n(self,TOPARSER p_nothing0,0,hid16,0);
}
static STATUS hid18(PRECC_DATA* self) {
PARSER hid17, p_uniq0;
return p_andparse0n (self,TOPARSER hid17,0,TOPARSER p_uniq0,0);
}
static STATUS hid19(PRECC_DATA* self) {
PARSER L_ENDLINE, hid18;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid18,0);
}
static STATUS hid20(PRECC_DATA* self) {
PARSER Symbols, hid19;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid19,0);
}
static STATUS hid21(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_POSTOP, hid20;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_POSTOP,0,TOPARSER hid20,0);
}
static VOID hid22(PRECC_DATA* self) {
 add_inrels(symbol,nsymbol); 
}
static STATUS hid23(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid22;
return p_attach0n(self,TOPARSER p_nothing0,0,hid22,0);
}
static STATUS hid24(PRECC_DATA* self) {
PARSER hid23, p_uniq0;
return p_andparse0n (self,TOPARSER hid23,0,TOPARSER p_uniq0,0);
}
static STATUS hid25(PRECC_DATA* self) {
PARSER L_ENDLINE, hid24;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid24,0);
}
static STATUS hid26(PRECC_DATA* self) {
PARSER Symbols, hid25;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid25,0);
}
static STATUS hid27(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_INREL, hid26;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_INREL,0,TOPARSER hid26,0);
}
static VOID hid28(PRECC_DATA* self) {
 add_prerels(symbol,nsymbol); 
}
static STATUS hid29(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid28;
return p_attach0n(self,TOPARSER p_nothing0,0,hid28,0);
}
static STATUS hid30(PRECC_DATA* self) {
PARSER hid29, p_uniq0;
return p_andparse0n (self,TOPARSER hid29,0,TOPARSER p_uniq0,0);
}
static STATUS hid31(PRECC_DATA* self) {
PARSER L_ENDLINE, hid30;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid30,0);
}
static STATUS hid32(PRECC_DATA* self) {
PARSER Symbols, hid31;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid31,0);
}
static STATUS hid33(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_PREREL, hid32;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_PREREL,0,TOPARSER hid32,0);
}
static VOID hid34(PRECC_DATA* self) {
 add_ingens(symbol,nsymbol); 
}
static STATUS hid35(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid34;
return p_attach0n(self,TOPARSER p_nothing0,0,hid34,0);
}
static STATUS hid36(PRECC_DATA* self) {
PARSER hid35, p_uniq0;
return p_andparse0n (self,TOPARSER hid35,0,TOPARSER p_uniq0,0);
}
static STATUS hid37(PRECC_DATA* self) {
PARSER L_ENDLINE, hid36;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid36,0);
}
static STATUS hid38(PRECC_DATA* self) {
PARSER Symbols, hid37;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid37,0);
}
static STATUS hid39(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_INGEN, hid38;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_INGEN,0,TOPARSER hid38,0);
}
static VOID hid40(PRECC_DATA* self) {
 add_pregens(symbol,nsymbol); 
}
static STATUS hid41(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid40;
return p_attach0n(self,TOPARSER p_nothing0,0,hid40,0);
}
static STATUS hid42(PRECC_DATA* self) {
PARSER hid41, p_uniq0;
return p_andparse0n (self,TOPARSER hid41,0,TOPARSER p_uniq0,0);
}
static STATUS hid43(PRECC_DATA* self) {
PARSER L_ENDLINE, hid42;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid42,0);
}
static STATUS hid44(PRECC_DATA* self) {
PARSER Symbols, hid43;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid43,0);
}
static STATUS hid45(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_PREGEN, hid44;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_PREGEN,0,TOPARSER hid44,0);
}
static VOID hid46(PRECC_DATA* self) {
 add_ignores(symbol,nsymbol); 
}
static STATUS hid47(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid46;
return p_attach0n(self,TOPARSER p_nothing0,0,hid46,0);
}
static STATUS hid48(PRECC_DATA* self) {
PARSER hid47, p_uniq0;
return p_andparse0n (self,TOPARSER hid47,0,TOPARSER p_uniq0,0);
}
static STATUS hid49(PRECC_DATA* self) {
PARSER L_ENDLINE, hid48;
return p_andparse0n (self,TOPARSER L_ENDLINE,0,TOPARSER hid48,0);
}
static STATUS hid50(PRECC_DATA* self) {
PARSER Symbols, hid49;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER hid49,0);
}
static STATUS hid51(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_IGNORE, hid50;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_IGNORE,0,TOPARSER hid50,0);
}
static STATUS hid52(PRECC_DATA* self) {
PARSER Symbols, L_ENDLINE;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER L_ENDLINE,0);
}
static STATUS hid53(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_UNCHECKED, hid52;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_UNCHECKED,0,TOPARSER hid52,0);
}
static STATUS hid54(PRECC_DATA* self) {
PARSER Symbols, L_ENDLINE;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER L_ENDLINE,0);
}
static STATUS hid55(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_TAME, hid54;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_TAME,0,TOPARSER hid54,0);
}
static STATUS hid56(PRECC_DATA* self) {
PARSER Symbols, L_ENDLINE;
return p_andparse0n (self,TOPARSER Symbols,0,TOPARSER L_ENDLINE,0);
}
static STATUS hid57(PRECC_DATA* self) {
PARSER L_PERCENT_PERCENT_TOKEN, hid56;
return p_andparse0n (self,TOPARSER L_PERCENT_PERCENT_TOKEN,0,TOPARSER hid56,0);
}
static STATUS hid58 (PRECC_DATA* self) {
PARSER hid55, hid57;
return p_orparse0n (self,TOPARSER hid55,0,TOPARSER hid57,0);
}
static STATUS hid59 (PRECC_DATA* self) {
PARSER hid53, hid58;
return p_orparse0n (self,TOPARSER hid53,0,TOPARSER hid58,0);
}
static STATUS hid60 (PRECC_DATA* self) {
PARSER hid51, hid59;
return p_orparse0n (self,TOPARSER hid51,0,TOPARSER hid59,0);
}
static STATUS hid61 (PRECC_DATA* self) {
PARSER hid45, hid60;
return p_orparse0n (self,TOPARSER hid45,0,TOPARSER hid60,0);
}
static STATUS hid62 (PRECC_DATA* self) {
PARSER hid39, hid61;
return p_orparse0n (self,TOPARSER hid39,0,TOPARSER hid61,0);
}
static STATUS hid63 (PRECC_DATA* self) {
PARSER hid33, hid62;
return p_orparse0n (self,TOPARSER hid33,0,TOPARSER hid62,0);
}
static STATUS hid64 (PRECC_DATA* self) {
PARSER hid27, hid63;
return p_orparse0n (self,TOPARSER hid27,0,TOPARSER hid63,0);
}
static STATUS hid65 (PRECC_DATA* self) {
PARSER hid21, hid64;
return p_orparse0n (self,TOPARSER hid21,0,TOPARSER hid64,0);
}
static STATUS hid66 (PRECC_DATA* self) {
PARSER hid15, hid65;
return p_orparse0n (self,TOPARSER hid15,0,TOPARSER hid65,0);
}
STATUS Directive(PRECC_DATA* self) {
PARSER hid66;
P_RETURN((TOPARSER hid66)(self),"Directive");
}
P_END

/* let this be * instead of + */

P_BEGIN
static VOID hid67(PRECC_DATA* self) {
 nsymbol=0; 
}
static STATUS hid68(PRECC_DATA* self) {
PARSER p_nothing0;ACTION hid67;
return p_attach0n(self,TOPARSER p_nothing0,0,hid67,0);
}
static VOID hid69(PRECC_DATA* self,VALUE x) {
 symbol[nsymbol++]=(int)(TOVALUE x); 
}
static STATUS hid70(PRECC_DATA* self,VALUE x) {
PARSER p_nothing0;ACTION hid69;
return p_attach0n(self,TOPARSER p_nothing0,0,hid69,P_SZ(1,1),x);
}
static STATUS hid71(PRECC_DATA* self) {
PARSER Symbol, hid70; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER Symbol)(self),(TOPARSER hid70)(self,x));
return p_tok;
}
static STATUS hid72(PRECC_DATA* self) {
PARSER hid71;
return p_many0n(self,TOPARSER hid71,0);
}
static STATUS hid73(PRECC_DATA* self) {
PARSER hid68, hid72;
return p_andparse0n (self,TOPARSER hid68,0,TOPARSER hid72,0);
}
STATUS Symbols(PRECC_DATA* self) {
PARSER hid73;
P_RETURN((TOPARSER hid73)(self),"Symbols");
}
P_END

/* symbols can't have new lines in */

P_BEGIN
STATUS Symbol(PRECC_DATA* self) {
PARSER L_SYMBOL;
P_RETURN((TOPARSER L_SYMBOL)(self),"Symbol");
}
P_END

P_BEGIN
STATUS Priority(PRECC_DATA* self) {
PARSER L_PRIORITY;
P_RETURN((TOPARSER L_PRIORITY)(self),"Priority");
}
P_END

P_BEGIN
static STATUS hid74(PRECC_DATA* self) {
PARSER L_COMMENTCHAR;
return p_some0n(self,TOPARSER L_COMMENTCHAR,0);
}
STATUS Comment(PRECC_DATA* self) {
PARSER hid74;
P_RETURN((TOPARSER hid74)(self),"Comment");
}
P_END

P_BEGIN
static STATUS hid75(PRECC_DATA* self) {
PARSER Sep, Item;
return p_andparse0n (self,TOPARSER Sep,0,TOPARSER Item,0);
}
static STATUS hid76(PRECC_DATA* self) {
PARSER hid75;
return p_many0n(self,TOPARSER hid75,0);
}
static STATUS hid77(PRECC_DATA* self) {
PARSER hid76, L_END_ZED;
return p_andparse0n (self,TOPARSER hid76,0,TOPARSER L_END_ZED,0);
}
static STATUS hid78(PRECC_DATA* self) {
PARSER Item, hid77;
return p_andparse0n (self,TOPARSER Item,0,TOPARSER hid77,0);
}
static STATUS hid79(PRECC_DATA* self) {
PARSER L_BEGIN_ZED, hid78;
return p_andparse0n (self,TOPARSER L_BEGIN_ZED,0,TOPARSER hid78,0);
}
STATUS Unboxed_Para(PRECC_DATA* self) {
PARSER hid79;
P_RETURN((TOPARSER hid79)(self),"Unboxed_Para");
}
P_END

P_BEGIN
static STATUS hid80(PRECC_DATA* self) {
PARSER L_COMMA, Ident;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Ident,0);
}
static STATUS hid81(PRECC_DATA* self) {
PARSER hid80;
return p_many0n(self,TOPARSER hid80,0);
}
static STATUS hid82(PRECC_DATA* self) {
PARSER hid81, L_CLOSEBRACKET;
return p_andparse0n (self,TOPARSER hid81,0,TOPARSER L_CLOSEBRACKET,0);
}
static STATUS hid83(PRECC_DATA* self) {
PARSER Ident, hid82;
return p_andparse0n (self,TOPARSER Ident,0,TOPARSER hid82,0);
}
static STATUS hid84(PRECC_DATA* self) {
PARSER L_OPENBRACKET, hid83;
return p_andparse0n (self,TOPARSER L_OPENBRACKET,0,TOPARSER hid83,0);
}
static STATUS hid85(PRECC_DATA* self) {
PARSER Gen_Formals;
return p_option0n(self,TOPARSER Gen_Formals,0);
}
static STATUS hid86(PRECC_DATA* self) {
PARSER L_DEFS, Schema_Exp;
return p_andparse0n (self,TOPARSER L_DEFS,0,TOPARSER Schema_Exp,0);
}
static STATUS hid87(PRECC_DATA* self) {
PARSER hid85, hid86;
return p_andparse0n (self,TOPARSER hid85,0,TOPARSER hid86,0);
}
static STATUS hid88(PRECC_DATA* self) {
PARSER Schema_Name, hid87;
return p_andparse0n (self,TOPARSER Schema_Name,0,TOPARSER hid87,0);
}
static STATUS hid89(PRECC_DATA* self) {
PARSER L_EQUALS_EQUALS, Expression;
return p_andparse0n (self,TOPARSER L_EQUALS_EQUALS,0,TOPARSER Expression,0);
}
static STATUS hid90(PRECC_DATA* self) {
PARSER Def_Lhs, hid89;
return p_andparse0n (self,TOPARSER Def_Lhs,0,TOPARSER hid89,0);
}
static STATUS hid91(PRECC_DATA* self) {
PARSER L_VERT, Branch;
return p_andparse0n (self,TOPARSER L_VERT,0,TOPARSER Branch,0);
}
static STATUS hid92(PRECC_DATA* self) {
PARSER hid91;
return p_many0n(self,TOPARSER hid91,0);
}
static STATUS hid93(PRECC_DATA* self) {
PARSER Branch, hid92;
return p_andparse0n (self,TOPARSER Branch,0,TOPARSER hid92,0);
}
static STATUS hid94(PRECC_DATA* self) {
PARSER L_COLON_COLON_EQUALS, hid93;
return p_andparse0n (self,TOPARSER L_COLON_COLON_EQUALS,0,TOPARSER hid93,0);
}
static STATUS hid95(PRECC_DATA* self) {
PARSER Ident, hid94;
return p_andparse0n (self,TOPARSER Ident,0,TOPARSER hid94,0);
}
static STATUS hid96 (PRECC_DATA* self) {
PARSER hid95, Predicate;
return p_orparse0n (self,TOPARSER hid95,0,TOPARSER Predicate,0);
}
static STATUS hid97 (PRECC_DATA* self) {
PARSER hid90, hid96;
return p_orparse0n (self,TOPARSER hid90,0,TOPARSER hid96,0);
}
static STATUS hid98 (PRECC_DATA* self) {
PARSER hid88, hid97;
return p_orparse0n (self,TOPARSER hid88,0,TOPARSER hid97,0);
}
static STATUS hid99 (PRECC_DATA* self) {
PARSER hid84, hid98;
return p_orparse0n (self,TOPARSER hid84,0,TOPARSER hid98,0);
}
STATUS Item(PRECC_DATA* self) {
PARSER hid99;
P_RETURN((TOPARSER hid99)(self),"Item");
}
P_END

/* making the Decl_Part execute pending actions so that the decls we just did
   can be seen */

P_BEGIN
static STATUS hid100(PRECC_DATA* self) {
PARSER L_WHERE, Axiom_Part;
return p_andparse0n (self,TOPARSER L_WHERE,0,TOPARSER Axiom_Part,0);
}
static STATUS hid101(PRECC_DATA* self) {
PARSER hid100;
return p_option0n(self,TOPARSER hid100,0);
}
static STATUS hid102(PRECC_DATA* self) {
PARSER hid101, L_END_AXDEF;
return p_andparse0n (self,TOPARSER hid101,0,TOPARSER L_END_AXDEF,0);
}
static STATUS hid103(PRECC_DATA* self) {
PARSER Decl_Part, hid102;
return p_andparse0n (self,TOPARSER Decl_Part,0,TOPARSER hid102,0);
}
static STATUS hid104(PRECC_DATA* self) {
PARSER L_BEGIN_AXDEF, hid103;
return p_andparse0n (self,TOPARSER L_BEGIN_AXDEF,0,TOPARSER hid103,0);
}
STATUS Axiomatic_Box(PRECC_DATA* self) {
PARSER hid104;
P_RETURN((TOPARSER hid104)(self),"Axiomatic_Box");
}
P_END

P_BEGIN
static STATUS hid105(PRECC_DATA* self) {
PARSER Gen_Formals;
return p_option0n(self,TOPARSER Gen_Formals,0);
}
static STATUS hid106(PRECC_DATA* self) {
PARSER L_WHERE, Axiom_Part;
return p_andparse0n (self,TOPARSER L_WHERE,0,TOPARSER Axiom_Part,0);
}
static STATUS hid107(PRECC_DATA* self) {
PARSER hid106;
return p_option0n(self,TOPARSER hid106,0);
}
static STATUS hid108(PRECC_DATA* self) {
PARSER hid107, L_END_SCHEMA;
return p_andparse0n (self,TOPARSER hid107,0,TOPARSER L_END_SCHEMA,0);
}
static STATUS hid109(PRECC_DATA* self) {
PARSER Decl_Part, hid108;
return p_andparse0n (self,TOPARSER Decl_Part,0,TOPARSER hid108,0);
}
static STATUS hid110(PRECC_DATA* self) {
PARSER hid105, hid109;
return p_andparse0n (self,TOPARSER hid105,0,TOPARSER hid109,0);
}
static STATUS hid111(PRECC_DATA* self) {
PARSER L_CLOSEBRACE, hid110;
return p_andparse0n (self,TOPARSER L_CLOSEBRACE,0,TOPARSER hid110,0);
}
static STATUS hid112(PRECC_DATA* self) {
PARSER Schema_Name, hid111;
return p_andparse0n (self,TOPARSER Schema_Name,0,TOPARSER hid111,0);
}
static STATUS hid113(PRECC_DATA* self) {
PARSER L_OPENBRACE, hid112;
return p_andparse0n (self,TOPARSER L_OPENBRACE,0,TOPARSER hid112,0);
}
static STATUS hid114(PRECC_DATA* self) {
PARSER L_BEGIN_SCHEMA, hid113;
return p_andparse0n (self,TOPARSER L_BEGIN_SCHEMA,0,TOPARSER hid113,0);
}
STATUS Schema_Box(PRECC_DATA* self) {
PARSER hid114;
P_RETURN((TOPARSER hid114)(self),"Schema_Box");
}
P_END

P_BEGIN
static STATUS hid115(PRECC_DATA* self) {
PARSER Gen_Formals;
return p_option0n(self,TOPARSER Gen_Formals,0);
}
static STATUS hid116(PRECC_DATA* self) {
PARSER L_WHERE, Axiom_Part;
return p_andparse0n (self,TOPARSER L_WHERE,0,TOPARSER Axiom_Part,0);
}
static STATUS hid117(PRECC_DATA* self) {
PARSER hid116;
return p_option0n(self,TOPARSER hid116,0);
}
static STATUS hid118(PRECC_DATA* self) {
PARSER hid117, L_END_GENDEF;
return p_andparse0n (self,TOPARSER hid117,0,TOPARSER L_END_GENDEF,0);
}
static STATUS hid119(PRECC_DATA* self) {
PARSER Decl_Part, hid118;
return p_andparse0n (self,TOPARSER Decl_Part,0,TOPARSER hid118,0);
}
static STATUS hid120(PRECC_DATA* self) {
PARSER hid115, hid119;
return p_andparse0n (self,TOPARSER hid115,0,TOPARSER hid119,0);
}
static STATUS hid121(PRECC_DATA* self) {
PARSER L_BEGIN_GENDEF, hid120;
return p_andparse0n (self,TOPARSER L_BEGIN_GENDEF,0,TOPARSER hid120,0);
}
STATUS Generic_Box(PRECC_DATA* self) {
PARSER hid121;
P_RETURN((TOPARSER hid121)(self),"Generic_Box");
}
P_END


P_BEGIN
static STATUS hid122(PRECC_DATA* self) {
PARSER Sep, Basic_Decl;
return p_andparse0n (self,TOPARSER Sep,0,TOPARSER Basic_Decl,0);
}
static STATUS hid123(PRECC_DATA* self) {
PARSER hid122;
return p_many0n(self,TOPARSER hid122,0);
}
static STATUS hid124(PRECC_DATA* self) {
PARSER Basic_Decl, hid123;
return p_andparse0n (self,TOPARSER Basic_Decl,0,TOPARSER hid123,0);
}
STATUS Decl_Part(PRECC_DATA* self) {
PARSER hid124;
P_RETURN((TOPARSER hid124)(self),"Decl_Part");
}
P_END

P_BEGIN
static STATUS hid125(PRECC_DATA* self) {
PARSER Sep, Predicate;
return p_andparse0n (self,TOPARSER Sep,0,TOPARSER Predicate,0);
}
static STATUS hid126(PRECC_DATA* self) {
PARSER hid125;
return p_many0n(self,TOPARSER hid125,0);
}
static STATUS hid127(PRECC_DATA* self) {
PARSER Predicate, hid126;
return p_andparse0n (self,TOPARSER Predicate,0,TOPARSER hid126,0);
}
STATUS Axiom_Part(PRECC_DATA* self) {
PARSER hid127;
P_RETURN((TOPARSER hid127)(self),"Axiom_Part");
}
P_END

P_BEGIN
static STATUS hid128 (PRECC_DATA* self) {
PARSER L_BACKSLASH_BACKSLASH, L_ALSO;
return p_orparse0n (self,TOPARSER L_BACKSLASH_BACKSLASH,0,TOPARSER L_ALSO,0);
}
static STATUS hid129 (PRECC_DATA* self) {
PARSER L_SEMICOLON, hid128;
return p_orparse0n (self,TOPARSER L_SEMICOLON,0,TOPARSER hid128,0);
}
STATUS Sep(PRECC_DATA* self) {
PARSER hid129;
P_RETURN((TOPARSER hid129)(self),"Sep");
}
P_END

/* I hope these next are distinguishable syntactically */

P_BEGIN
static STATUS hid130(PRECC_DATA* self) {
PARSER Gen_Formals;
return p_option0n(self,TOPARSER Gen_Formals,0);
}
static STATUS hid131(PRECC_DATA* self) {
PARSER Var_Name, hid130;
return p_andparse0n (self,TOPARSER Var_Name,0,TOPARSER hid130,0);
}
static STATUS hid132(PRECC_DATA* self) {
PARSER Pre_Gen, Ident;
return p_andparse0n (self,TOPARSER Pre_Gen,0,TOPARSER Ident,0);
}
static STATUS hid133(PRECC_DATA* self) {
PARSER In_Gen, Ident;
return p_andparse0n (self,TOPARSER In_Gen,0,TOPARSER Ident,0);
}
static STATUS hid134(PRECC_DATA* self) {
PARSER Ident, hid133;
return p_andparse0n (self,TOPARSER Ident,0,TOPARSER hid133,0);
}
static STATUS hid135 (PRECC_DATA* self) {
PARSER hid132, hid134;
return p_orparse0n (self,TOPARSER hid132,0,TOPARSER hid134,0);
}
static STATUS hid136 (PRECC_DATA* self) {
PARSER hid131, hid135;
return p_orparse0n (self,TOPARSER hid131,0,TOPARSER hid135,0);
}
STATUS Def_Lhs(PRECC_DATA* self) {
PARSER hid136;
P_RETURN((TOPARSER hid136)(self),"Def_Lhs");
}
P_END

/* I've changed the order here, in case I can't distinguish Var_Name and Ident
**/

P_BEGIN
static STATUS hid137(PRECC_DATA* self) {
PARSER Expression, L_RDATA;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER L_RDATA,0);
}
static STATUS hid138(PRECC_DATA* self) {
PARSER L_LDATA, hid137;
return p_andparse0n (self,TOPARSER L_LDATA,0,TOPARSER hid137,0);
}
static STATUS hid139(PRECC_DATA* self) {
PARSER Var_Name, hid138;
return p_andparse0n (self,TOPARSER Var_Name,0,TOPARSER hid138,0);
}
static STATUS hid140 (PRECC_DATA* self) {
PARSER hid139, Ident;
return p_orparse0n (self,TOPARSER hid139,0,TOPARSER Ident,0);
}
STATUS Branch(PRECC_DATA* self) {
PARSER hid140;
P_RETURN((TOPARSER hid140)(self),"Branch");
}
P_END

/* the next is in inefficient form - but I'll stick to the text */

P_BEGIN
static STATUS hid141(PRECC_DATA* self) {
PARSER L_AT, Schema_Exp;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Schema_Exp,0);
}
static STATUS hid142(PRECC_DATA* self) {
PARSER Schema_Text, hid141;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid141,0);
}
static STATUS hid143(PRECC_DATA* self) {
PARSER L_FORALL, hid142;
return p_andparse0n (self,TOPARSER L_FORALL,0,TOPARSER hid142,0);
}
static STATUS hid144(PRECC_DATA* self) {
PARSER L_AT, Schema_Exp;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Schema_Exp,0);
}
static STATUS hid145(PRECC_DATA* self) {
PARSER Schema_Text, hid144;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid144,0);
}
static STATUS hid146(PRECC_DATA* self) {
PARSER L_EXISTS, hid145;
return p_andparse0n (self,TOPARSER L_EXISTS,0,TOPARSER hid145,0);
}
static STATUS hid147(PRECC_DATA* self) {
PARSER L_AT, Schema_Exp;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Schema_Exp,0);
}
static STATUS hid148(PRECC_DATA* self) {
PARSER Schema_Text, hid147;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid147,0);
}
static STATUS hid149(PRECC_DATA* self) {
PARSER L_EXISTS_1, hid148;
return p_andparse0n (self,TOPARSER L_EXISTS_1,0,TOPARSER hid148,0);
}
static STATUS hid150 (PRECC_DATA* self) {
PARSER hid149, Schema_Exp_1;
return p_orparse0n (self,TOPARSER hid149,0,TOPARSER Schema_Exp_1,0);
}
static STATUS hid151 (PRECC_DATA* self) {
PARSER hid146, hid150;
return p_orparse0n (self,TOPARSER hid146,0,TOPARSER hid150,0);
}
static STATUS hid152 (PRECC_DATA* self) {
PARSER hid143, hid151;
return p_orparse0n (self,TOPARSER hid143,0,TOPARSER hid151,0);
}
STATUS Schema_Exp(PRECC_DATA* self) {
PARSER hid152;
P_RETURN((TOPARSER hid152)(self),"Schema_Exp");
}
P_END

/* I can't see any sense in distinguishing left and right associativity
** here since that's really something to be left to the build function.
** Therefore I've deviated wildly from the text. To make left assoc
** easier to build I've bundled all the stuff before a final left assoc op
** into a single list. To make right assoc easier to build, I've
** handled it recursively.
**/

/* here are the right assoc ops, on top, recursion and all */

P_BEGIN
static STATUS hid153(PRECC_DATA* self) {
PARSER L_IMPLIES, Schema_Exp_1;
return p_andparse0n (self,TOPARSER L_IMPLIES,0,TOPARSER Schema_Exp_1,0);
}
static STATUS hid154(PRECC_DATA* self) {
PARSER hid153;
return p_option0n(self,TOPARSER hid153,0);
}
static STATUS hid155(PRECC_DATA* self) {
PARSER Schema_Exp_2, hid154;
return p_andparse0n (self,TOPARSER Schema_Exp_2,0,TOPARSER hid154,0);
}
STATUS Schema_Exp_1(PRECC_DATA* self) {
PARSER hid155;
P_RETURN((TOPARSER hid155)(self),"Schema_Exp_1");
}
P_END

/* now we look for a series of L_HIDES separated by left assoc ops */

P_BEGIN
static STATUS hid156 (PRECC_DATA* self) {
PARSER L_SEMI, L_PIPE;
return p_orparse0n (self,TOPARSER L_SEMI,0,TOPARSER L_PIPE,0);
}
static STATUS hid157 (PRECC_DATA* self) {
PARSER L_PROJECT, hid156;
return p_orparse0n (self,TOPARSER L_PROJECT,0,TOPARSER hid156,0);
}
static STATUS hid158 (PRECC_DATA* self) {
PARSER L_IFF, hid157;
return p_orparse0n (self,TOPARSER L_IFF,0,TOPARSER hid157,0);
}
static STATUS hid159 (PRECC_DATA* self) {
PARSER L_LOR, hid158;
return p_orparse0n (self,TOPARSER L_LOR,0,TOPARSER hid158,0);
}
static STATUS hid160 (PRECC_DATA* self) {
PARSER L_LAND, hid159;
return p_orparse0n (self,TOPARSER L_LAND,0,TOPARSER hid159,0);
}
static STATUS hid161(PRECC_DATA* self) {
PARSER hid160, Schema_Exp_3;
return p_andparse0n (self,TOPARSER hid160,0,TOPARSER Schema_Exp_3,0);
}
static STATUS hid162(PRECC_DATA* self) {
PARSER hid161;
return p_many0n(self,TOPARSER hid161,0);
}
static STATUS hid163(PRECC_DATA* self) {
PARSER Schema_Exp_3, hid162;
return p_andparse0n (self,TOPARSER Schema_Exp_3,0,TOPARSER hid162,0);
}
STATUS Schema_Exp_2(PRECC_DATA* self) {
PARSER hid163;
P_RETURN((TOPARSER hid163)(self),"Schema_Exp_2");
}
P_END

/* and before a L_HIDE we expect a series separated by left assoc ops */

P_BEGIN
static STATUS hid164 (PRECC_DATA* self) {
PARSER L_SEMI, L_PIPE;
return p_orparse0n (self,TOPARSER L_SEMI,0,TOPARSER L_PIPE,0);
}
static STATUS hid165 (PRECC_DATA* self) {
PARSER L_PROJECT, hid164;
return p_orparse0n (self,TOPARSER L_PROJECT,0,TOPARSER hid164,0);
}
static STATUS hid166 (PRECC_DATA* self) {
PARSER L_IFF, hid165;
return p_orparse0n (self,TOPARSER L_IFF,0,TOPARSER hid165,0);
}
static STATUS hid167 (PRECC_DATA* self) {
PARSER L_LOR, hid166;
return p_orparse0n (self,TOPARSER L_LOR,0,TOPARSER hid166,0);
}
static STATUS hid168 (PRECC_DATA* self) {
PARSER L_LAND, hid167;
return p_orparse0n (self,TOPARSER L_LAND,0,TOPARSER hid167,0);
}
static STATUS hid169(PRECC_DATA* self) {
PARSER hid168, Schema_Exp_U;
return p_andparse0n (self,TOPARSER hid168,0,TOPARSER Schema_Exp_U,0);
}
static STATUS hid170(PRECC_DATA* self) {
PARSER hid169;
return p_many0n(self,TOPARSER hid169,0);
}
static STATUS hid171(PRECC_DATA* self) {
PARSER L_COMMA, Decl_Name;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Decl_Name,0);
}
static STATUS hid172(PRECC_DATA* self) {
PARSER hid171;
return p_many0n(self,TOPARSER hid171,0);
}
static STATUS hid173(PRECC_DATA* self) {
PARSER hid172, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER hid172,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid174(PRECC_DATA* self) {
PARSER Decl_Name, hid173;
return p_andparse0n (self,TOPARSER Decl_Name,0,TOPARSER hid173,0);
}
static STATUS hid175(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid174;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid174,0);
}
static STATUS hid176(PRECC_DATA* self) {
PARSER L_HIDE, hid175;
return p_andparse0n (self,TOPARSER L_HIDE,0,TOPARSER hid175,0);
}
static STATUS hid177(PRECC_DATA* self) {
PARSER hid176;
return p_many0n(self,TOPARSER hid176,0);
}
static STATUS hid178(PRECC_DATA* self) {
PARSER hid170, hid177;
return p_andparse0n (self,TOPARSER hid170,0,TOPARSER hid177,0);
}
static STATUS hid179(PRECC_DATA* self) {
PARSER Schema_Exp_U, hid178;
return p_andparse0n (self,TOPARSER Schema_Exp_U,0,TOPARSER hid178,0);
}
STATUS Schema_Exp_3(PRECC_DATA* self) {
PARSER hid179;
P_RETURN((TOPARSER hid179)(self),"Schema_Exp_3");
}
P_END

/* and these are definitely atomic */

P_BEGIN
static STATUS hid180(PRECC_DATA* self) {
PARSER Schema_Text, L_CLOSEBRACKET;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER L_CLOSEBRACKET,0);
}
static STATUS hid181(PRECC_DATA* self) {
PARSER L_OPENBRACKET, hid180;
return p_andparse0n (self,TOPARSER L_OPENBRACKET,0,TOPARSER hid180,0);
}
static STATUS hid182(PRECC_DATA* self) {
PARSER L_LNOT, Schema_Exp_U;
return p_andparse0n (self,TOPARSER L_LNOT,0,TOPARSER Schema_Exp_U,0);
}
static STATUS hid183(PRECC_DATA* self) {
PARSER L_PRE, Schema_Exp_U;
return p_andparse0n (self,TOPARSER L_PRE,0,TOPARSER Schema_Exp_U,0);
}
static STATUS hid184(PRECC_DATA* self) {
PARSER Schema_Exp, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER Schema_Exp,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid185(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid184;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid184,0);
}
static STATUS hid186 (PRECC_DATA* self) {
PARSER hid185, Schema_Ref;
return p_orparse0n (self,TOPARSER hid185,0,TOPARSER Schema_Ref,0);
}
static STATUS hid187 (PRECC_DATA* self) {
PARSER hid183, hid186;
return p_orparse0n (self,TOPARSER hid183,0,TOPARSER hid186,0);
}
static STATUS hid188 (PRECC_DATA* self) {
PARSER hid182, hid187;
return p_orparse0n (self,TOPARSER hid182,0,TOPARSER hid187,0);
}
static STATUS hid189 (PRECC_DATA* self) {
PARSER hid181, hid188;
return p_orparse0n (self,TOPARSER hid181,0,TOPARSER hid188,0);
}
STATUS Schema_Exp_U(PRECC_DATA* self) {
PARSER hid189;
P_RETURN((TOPARSER hid189)(self),"Schema_Exp_U");
}
P_END


P_BEGIN
static STATUS hid190(PRECC_DATA* self) {
PARSER L_VERT, Predicate;
return p_andparse0n (self,TOPARSER L_VERT,0,TOPARSER Predicate,0);
}
static STATUS hid191(PRECC_DATA* self) {
PARSER hid190;
return p_option0n(self,TOPARSER hid190,0);
}
static STATUS hid192(PRECC_DATA* self) {
PARSER Declaration, hid191;
return p_andparse0n (self,TOPARSER Declaration,0,TOPARSER hid191,0);
}
STATUS Schema_Text(PRECC_DATA* self) {
PARSER hid192;
P_RETURN((TOPARSER hid192)(self),"Schema_Text");
}
P_END

P_BEGIN
static STATUS hid193(PRECC_DATA* self) {
PARSER Gen_Actuals;
return p_option0n(self,TOPARSER Gen_Actuals,0);
}
static STATUS hid194(PRECC_DATA* self) {
PARSER Renaming;
return p_option0n(self,TOPARSER Renaming,0);
}
static STATUS hid195(PRECC_DATA* self) {
PARSER hid193, hid194;
return p_andparse0n (self,TOPARSER hid193,0,TOPARSER hid194,0);
}
static STATUS hid196(PRECC_DATA* self) {
PARSER Decoration, hid195;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid195,0);
}
static STATUS hid197(PRECC_DATA* self) {
PARSER Schema_Name, hid196;
return p_andparse0n (self,TOPARSER Schema_Name,0,TOPARSER hid196,0);
}
STATUS Schema_Ref(PRECC_DATA* self) {
PARSER hid197;
P_RETURN((TOPARSER hid197)(self),"Schema_Ref");
}
P_END

P_BEGIN
static STATUS hid198(PRECC_DATA* self) {
PARSER L_SLASH, Decl_Name;
return p_andparse0n (self,TOPARSER L_SLASH,0,TOPARSER Decl_Name,0);
}
static STATUS hid199(PRECC_DATA* self) {
PARSER Decl_Name, hid198;
return p_andparse0n (self,TOPARSER Decl_Name,0,TOPARSER hid198,0);
}
static STATUS hid200(PRECC_DATA* self) {
PARSER L_COMMA, hid199;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER hid199,0);
}
static STATUS hid201(PRECC_DATA* self) {
PARSER hid200;
return p_many0n(self,TOPARSER hid200,0);
}
static STATUS hid202(PRECC_DATA* self) {
PARSER hid201, L_CLOSEBRACKET;
return p_andparse0n (self,TOPARSER hid201,0,TOPARSER L_CLOSEBRACKET,0);
}
static STATUS hid203(PRECC_DATA* self) {
PARSER Decl_Name, hid202;
return p_andparse0n (self,TOPARSER Decl_Name,0,TOPARSER hid202,0);
}
static STATUS hid204(PRECC_DATA* self) {
PARSER L_SLASH, hid203;
return p_andparse0n (self,TOPARSER L_SLASH,0,TOPARSER hid203,0);
}
static STATUS hid205(PRECC_DATA* self) {
PARSER Decl_Name, hid204;
return p_andparse0n (self,TOPARSER Decl_Name,0,TOPARSER hid204,0);
}
static STATUS hid206(PRECC_DATA* self) {
PARSER L_OPENBRACKET, hid205;
return p_andparse0n (self,TOPARSER L_OPENBRACKET,0,TOPARSER hid205,0);
}
STATUS Renaming(PRECC_DATA* self) {
PARSER hid206;
P_RETURN((TOPARSER hid206)(self),"Renaming");
}
P_END

P_BEGIN
static STATUS hid207(PRECC_DATA* self) {
PARSER L_SEMICOLON, Basic_Decl;
return p_andparse0n (self,TOPARSER L_SEMICOLON,0,TOPARSER Basic_Decl,0);
}
static STATUS hid208(PRECC_DATA* self) {
PARSER hid207;
return p_many0n(self,TOPARSER hid207,0);
}
static STATUS hid209(PRECC_DATA* self) {
PARSER Basic_Decl, hid208;
return p_andparse0n (self,TOPARSER Basic_Decl,0,TOPARSER hid208,0);
}
STATUS Declaration(PRECC_DATA* self) {
PARSER hid209;
P_RETURN((TOPARSER hid209)(self),"Declaration");
}
P_END

P_BEGIN
static STATUS hid210(PRECC_DATA* self) {
PARSER L_COMMA, Decl_Name;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Decl_Name,0);
}
static STATUS hid211(PRECC_DATA* self) {
PARSER hid210;
return p_many0n(self,TOPARSER hid210,0);
}
static STATUS hid212(PRECC_DATA* self) {
PARSER L_COLON, Expression;
return p_andparse0n (self,TOPARSER L_COLON,0,TOPARSER Expression,0);
}
static STATUS hid213(PRECC_DATA* self) {
PARSER hid211, hid212;
return p_andparse0n (self,TOPARSER hid211,0,TOPARSER hid212,0);
}
static STATUS hid214(PRECC_DATA* self) {
PARSER Decl_Name, hid213;
return p_andparse0n (self,TOPARSER Decl_Name,0,TOPARSER hid213,0);
}
static STATUS hid215 (PRECC_DATA* self) {
PARSER hid214, Schema_Ref;
return p_orparse0n (self,TOPARSER hid214,0,TOPARSER Schema_Ref,0);
}
STATUS Basic_Decl(PRECC_DATA* self) {
PARSER hid215;
P_RETURN((TOPARSER hid215)(self),"Basic_Decl");
}
P_END

P_BEGIN
static STATUS hid216(PRECC_DATA* self) {
PARSER L_AT, Predicate;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Predicate,0);
}
static STATUS hid217(PRECC_DATA* self) {
PARSER Schema_Text, hid216;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid216,0);
}
static STATUS hid218(PRECC_DATA* self) {
PARSER L_FORALL, hid217;
return p_andparse0n (self,TOPARSER L_FORALL,0,TOPARSER hid217,0);
}
static STATUS hid219(PRECC_DATA* self) {
PARSER L_AT, Predicate;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Predicate,0);
}
static STATUS hid220(PRECC_DATA* self) {
PARSER Schema_Text, hid219;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid219,0);
}
static STATUS hid221(PRECC_DATA* self) {
PARSER L_EXISTS, hid220;
return p_andparse0n (self,TOPARSER L_EXISTS,0,TOPARSER hid220,0);
}
static STATUS hid222(PRECC_DATA* self) {
PARSER L_AT, Predicate;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Predicate,0);
}
static STATUS hid223(PRECC_DATA* self) {
PARSER Schema_Text, hid222;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid222,0);
}
static STATUS hid224(PRECC_DATA* self) {
PARSER L_EXISTS_1, hid223;
return p_andparse0n (self,TOPARSER L_EXISTS_1,0,TOPARSER hid223,0);
}
static STATUS hid225(PRECC_DATA* self) {
PARSER L_SEMICOLON, Let_Def;
return p_andparse0n (self,TOPARSER L_SEMICOLON,0,TOPARSER Let_Def,0);
}
static STATUS hid226(PRECC_DATA* self) {
PARSER hid225;
return p_many0n(self,TOPARSER hid225,0);
}
static STATUS hid227(PRECC_DATA* self) {
PARSER L_AT, Predicate;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Predicate,0);
}
static STATUS hid228(PRECC_DATA* self) {
PARSER hid226, hid227;
return p_andparse0n (self,TOPARSER hid226,0,TOPARSER hid227,0);
}
static STATUS hid229(PRECC_DATA* self) {
PARSER Let_Def, hid228;
return p_andparse0n (self,TOPARSER Let_Def,0,TOPARSER hid228,0);
}
static STATUS hid230(PRECC_DATA* self) {
PARSER L_LET, hid229;
return p_andparse0n (self,TOPARSER L_LET,0,TOPARSER hid229,0);
}
static STATUS hid231 (PRECC_DATA* self) {
PARSER hid230, Predicate_1;
return p_orparse0n (self,TOPARSER hid230,0,TOPARSER Predicate_1,0);
}
static STATUS hid232 (PRECC_DATA* self) {
PARSER hid224, hid231;
return p_orparse0n (self,TOPARSER hid224,0,TOPARSER hid231,0);
}
static STATUS hid233 (PRECC_DATA* self) {
PARSER hid221, hid232;
return p_orparse0n (self,TOPARSER hid221,0,TOPARSER hid232,0);
}
static STATUS hid234 (PRECC_DATA* self) {
PARSER hid218, hid233;
return p_orparse0n (self,TOPARSER hid218,0,TOPARSER hid233,0);
}
STATUS Predicate(PRECC_DATA* self) {
PARSER hid234;
P_RETURN((TOPARSER hid234)(self),"Predicate");
}
P_END

/* are L_TRUE and L_FALSE backslashed ? */

P_BEGIN
static STATUS hid235(PRECC_DATA* self) {
PARSER L_IMPLIES, Predicate_1;
return p_andparse0n (self,TOPARSER L_IMPLIES,0,TOPARSER Predicate_1,0);
}
static STATUS hid236(PRECC_DATA* self) {
PARSER hid235;
return p_option0n(self,TOPARSER hid235,0);
}
static STATUS hid237(PRECC_DATA* self) {
PARSER Predicate_2, hid236;
return p_andparse0n (self,TOPARSER Predicate_2,0,TOPARSER hid236,0);
}
STATUS Predicate_1(PRECC_DATA* self) {
PARSER hid237;
P_RETURN((TOPARSER hid237)(self),"Predicate_1");
}
P_END

P_BEGIN
static STATUS hid238 (PRECC_DATA* self) {
PARSER L_LOR, L_IFF;
return p_orparse0n (self,TOPARSER L_LOR,0,TOPARSER L_IFF,0);
}
static STATUS hid239 (PRECC_DATA* self) {
PARSER L_LAND, hid238;
return p_orparse0n (self,TOPARSER L_LAND,0,TOPARSER hid238,0);
}
static STATUS hid240(PRECC_DATA* self) {
PARSER hid239, Predicate_U;
return p_andparse0n (self,TOPARSER hid239,0,TOPARSER Predicate_U,0);
}
static STATUS hid241(PRECC_DATA* self) {
PARSER hid240;
return p_many0n(self,TOPARSER hid240,0);
}
static STATUS hid242(PRECC_DATA* self) {
PARSER Predicate_U, hid241;
return p_andparse0n (self,TOPARSER Predicate_U,0,TOPARSER hid241,0);
}
STATUS Predicate_2(PRECC_DATA* self) {
PARSER hid242;
P_RETURN((TOPARSER hid242)(self),"Predicate_2");
}
P_END

P_BEGIN
static STATUS hid243(PRECC_DATA* self) {
PARSER Rel, Expression;
return p_andparse0n (self,TOPARSER Rel,0,TOPARSER Expression,0);
}
static STATUS hid244(PRECC_DATA* self) {
PARSER hid243;
return p_many0n(self,TOPARSER hid243,0);
}
static STATUS hid245(PRECC_DATA* self) {
PARSER Expression, hid244;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER hid244,0);
}
static STATUS hid246(PRECC_DATA* self) {
PARSER Pre_Rel, Expression;
return p_andparse0n (self,TOPARSER Pre_Rel,0,TOPARSER Expression,0);
}
static STATUS hid247(PRECC_DATA* self) {
PARSER L_PRE, Schema_Ref;
return p_andparse0n (self,TOPARSER L_PRE,0,TOPARSER Schema_Ref,0);
}
static STATUS hid248(PRECC_DATA* self) {
PARSER L_LNOT, Predicate_1;
return p_andparse0n (self,TOPARSER L_LNOT,0,TOPARSER Predicate_1,0);
}
static STATUS hid249(PRECC_DATA* self) {
PARSER Predicate, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER Predicate,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid250(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid249;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid249,0);
}
static STATUS hid251 (PRECC_DATA* self) {
PARSER hid250, Schema_Ref;
return p_orparse0n (self,TOPARSER hid250,0,TOPARSER Schema_Ref,0);
}
static STATUS hid252 (PRECC_DATA* self) {
PARSER hid248, hid251;
return p_orparse0n (self,TOPARSER hid248,0,TOPARSER hid251,0);
}
static STATUS hid253 (PRECC_DATA* self) {
PARSER L_FALSE, hid252;
return p_orparse0n (self,TOPARSER L_FALSE,0,TOPARSER hid252,0);
}
static STATUS hid254 (PRECC_DATA* self) {
PARSER L_TRUE, hid253;
return p_orparse0n (self,TOPARSER L_TRUE,0,TOPARSER hid253,0);
}
static STATUS hid255 (PRECC_DATA* self) {
PARSER hid247, hid254;
return p_orparse0n (self,TOPARSER hid247,0,TOPARSER hid254,0);
}
static STATUS hid256 (PRECC_DATA* self) {
PARSER hid246, hid255;
return p_orparse0n (self,TOPARSER hid246,0,TOPARSER hid255,0);
}
static STATUS hid257 (PRECC_DATA* self) {
PARSER hid245, hid256;
return p_orparse0n (self,TOPARSER hid245,0,TOPARSER hid256,0);
}
STATUS Predicate_U(PRECC_DATA* self) {
PARSER hid257;
P_RETURN((TOPARSER hid257)(self),"Predicate_U");
}
P_END

P_BEGIN
static STATUS hid258(PRECC_DATA* self) {
PARSER Ident, L_CLOSEBRACE;
return p_andparse0n (self,TOPARSER Ident,0,TOPARSER L_CLOSEBRACE,0);
}
static STATUS hid259(PRECC_DATA* self) {
PARSER L_OPENBRACE, hid258;
return p_andparse0n (self,TOPARSER L_OPENBRACE,0,TOPARSER hid258,0);
}
static STATUS hid260(PRECC_DATA* self) {
PARSER L_INREL, hid259;
return p_andparse0n (self,TOPARSER L_INREL,0,TOPARSER hid259,0);
}
static STATUS hid261 (PRECC_DATA* self) {
PARSER In_Rel, hid260;
return p_orparse0n (self,TOPARSER In_Rel,0,TOPARSER hid260,0);
}
static STATUS hid262 (PRECC_DATA* self) {
PARSER L_IN, hid261;
return p_orparse0n (self,TOPARSER L_IN,0,TOPARSER hid261,0);
}
static STATUS hid263 (PRECC_DATA* self) {
PARSER L_EQUALS, hid262;
return p_orparse0n (self,TOPARSER L_EQUALS,0,TOPARSER hid262,0);
}
STATUS Rel(PRECC_DATA* self) {
PARSER hid263;
P_RETURN((TOPARSER hid263)(self),"Rel");
}
P_END

P_BEGIN
static STATUS hid264(PRECC_DATA* self) {
PARSER L_EQUALS_EQUALS, Expression;
return p_andparse0n (self,TOPARSER L_EQUALS_EQUALS,0,TOPARSER Expression,0);
}
static STATUS hid265(PRECC_DATA* self) {
PARSER Var_Name, hid264;
return p_andparse0n (self,TOPARSER Var_Name,0,TOPARSER hid264,0);
}
STATUS Let_Def(PRECC_DATA* self) {
PARSER hid265;
P_RETURN((TOPARSER hid265)(self),"Let_Def");
}
P_END

P_BEGIN
static STATUS hid266(PRECC_DATA* self) {
PARSER L_AT, Expression;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Expression,0);
}
static STATUS hid267(PRECC_DATA* self) {
PARSER Schema_Text, hid266;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid266,0);
}
static STATUS hid268(PRECC_DATA* self) {
PARSER L_LAMBDA, hid267;
return p_andparse0n (self,TOPARSER L_LAMBDA,0,TOPARSER hid267,0);
}
static STATUS hid269(PRECC_DATA* self) {
PARSER L_AT, Expression;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Expression,0);
}
static STATUS hid270(PRECC_DATA* self) {
PARSER hid269;
return p_option0n(self,TOPARSER hid269,0);
}
static STATUS hid271(PRECC_DATA* self) {
PARSER Schema_Text, hid270;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid270,0);
}
static STATUS hid272(PRECC_DATA* self) {
PARSER L_MU, hid271;
return p_andparse0n (self,TOPARSER L_MU,0,TOPARSER hid271,0);
}
static STATUS hid273(PRECC_DATA* self) {
PARSER L_SEMICOLON, Let_Def;
return p_andparse0n (self,TOPARSER L_SEMICOLON,0,TOPARSER Let_Def,0);
}
static STATUS hid274(PRECC_DATA* self) {
PARSER hid273;
return p_many0n(self,TOPARSER hid273,0);
}
static STATUS hid275(PRECC_DATA* self) {
PARSER L_AT, Expression;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Expression,0);
}
static STATUS hid276(PRECC_DATA* self) {
PARSER hid274, hid275;
return p_andparse0n (self,TOPARSER hid274,0,TOPARSER hid275,0);
}
static STATUS hid277(PRECC_DATA* self) {
PARSER Let_Def, hid276;
return p_andparse0n (self,TOPARSER Let_Def,0,TOPARSER hid276,0);
}
static STATUS hid278(PRECC_DATA* self) {
PARSER L_LET, hid277;
return p_andparse0n (self,TOPARSER L_LET,0,TOPARSER hid277,0);
}
static STATUS hid279 (PRECC_DATA* self) {
PARSER hid278, Expression;
return p_orparse0n (self,TOPARSER hid278,0,TOPARSER Expression,0);
}
static STATUS hid280 (PRECC_DATA* self) {
PARSER hid272, hid279;
return p_orparse0n (self,TOPARSER hid272,0,TOPARSER hid279,0);
}
static STATUS hid281 (PRECC_DATA* self) {
PARSER hid268, hid280;
return p_orparse0n (self,TOPARSER hid268,0,TOPARSER hid280,0);
}
STATUS Expression_0(PRECC_DATA* self) {
PARSER hid281;
P_RETURN((TOPARSER hid281)(self),"Expression_0");
}
P_END


P_BEGIN
static STATUS hid282(PRECC_DATA* self) {
PARSER L_ELSE, Expression;
return p_andparse0n (self,TOPARSER L_ELSE,0,TOPARSER Expression,0);
}
static STATUS hid283(PRECC_DATA* self) {
PARSER Expression, hid282;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER hid282,0);
}
static STATUS hid284(PRECC_DATA* self) {
PARSER L_THEN, hid283;
return p_andparse0n (self,TOPARSER L_THEN,0,TOPARSER hid283,0);
}
static STATUS hid285(PRECC_DATA* self) {
PARSER Predicate, hid284;
return p_andparse0n (self,TOPARSER Predicate,0,TOPARSER hid284,0);
}
static STATUS hid286(PRECC_DATA* self) {
PARSER L_IF, hid285;
return p_andparse0n (self,TOPARSER L_IF,0,TOPARSER hid285,0);
}
static STATUS hid287 (PRECC_DATA* self) {
PARSER hid286, Expression_1;
return p_orparse0n (self,TOPARSER hid286,0,TOPARSER Expression_1,0);
}
STATUS Expression(PRECC_DATA* self) {
PARSER hid287;
P_RETURN((TOPARSER hid287)(self),"Expression");
}
P_END

/* generic expression with binding powers m (1:highest) to l (6:lowest) */

extern int level(int);

P_BEGIN
static STATUS hid288(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
return p_test0(self,l<m);
}
static STATUS hid289(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER hid288, dummy2;
return p_andparse0n (self,TOPARSER hid288,P_SZ(4,0),u,s,l,m,TOPARSER u,0);
}
static STATUS hid290(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
return p_test0(self,l>=m);
}
static STATUS hid291(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m,VALUE x) {
return p_test0(self,level((int)x)==(int)l);
}
static STATUS hid292(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m,VALUE x) {
PARSER hid291, binex;
return p_andparse0n (self,TOPARSER hid291,P_SZ(5,1),u,s,l,m,x,TOPARSER binex,P_SZ(4,0),u,s,l-1,m);
}
static STATUS hid293(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER dummy1, hid292; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER s)(self),(TOPARSER hid292)(self,u,s,l,m,x));
return p_tok;
}
static STATUS hid294(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER hid293;
return p_many0n(self,TOPARSER hid293,P_SZ(4,0),u,s,l,m);
}
static STATUS hid295(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER binex, hid294;
return p_andparse0n (self,TOPARSER binex,P_SZ(4,0),u,s,l-1,m,TOPARSER hid294,P_SZ(4,0),u,s,l,m);
}
static STATUS hid296(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER hid290, hid295;
return p_andparse0n (self,TOPARSER hid290,P_SZ(4,0),u,s,l,m,TOPARSER hid295,P_SZ(4,0),u,s,l,m);
}
static STATUS hid297 (PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER hid289, hid296;
return p_orparse0n (self,TOPARSER hid289,P_SZ(4,0),u,s,l,m,TOPARSER hid296,P_SZ(4,0),u,s,l,m);
}
STATUS binex(PRECC_DATA* self,PARAM u,PARAM s,PARAM l,PARAM m) {
PARSER hid297;
P_RETURN((TOPARSER hid297)(self,u,s,l,m),"binex");
}
P_END

PARSER Expression_1A, In_Gen;

P_BEGIN
STATUS Expression_1(PRECC_DATA* self) {
PARSER binex;
P_RETURN((TOPARSER binex)(self,Expression_1A,In_Gen,(PARAM)6,(PARAM)1),"Expression_1");
}
P_END

P_BEGIN
static STATUS hid298(PRECC_DATA* self) {
PARSER L_CROSS, Expression_2;
return p_andparse0n (self,TOPARSER L_CROSS,0,TOPARSER Expression_2,0);
}
static STATUS hid299(PRECC_DATA* self) {
PARSER hid298;
return p_many0n(self,TOPARSER hid298,0);
}
static STATUS hid300(PRECC_DATA* self) {
PARSER Expression_2, hid299;
return p_andparse0n (self,TOPARSER Expression_2,0,TOPARSER hid299,0);
}
STATUS Expression_1A(PRECC_DATA* self) {
PARSER hid300;
P_RETURN((TOPARSER hid300)(self),"Expression_1A");
}
P_END

PARSER Expression_2A, In_Fun;

P_BEGIN
STATUS Expression_2(PRECC_DATA* self) {
PARSER binex;
P_RETURN((TOPARSER binex)(self,Expression_2A,In_Fun,(PARAM)6,(PARAM)1),"Expression_2");
}
P_END

P_BEGIN
static STATUS hid301(PRECC_DATA* self) {
PARSER L_POWER, Expression_4;
return p_andparse0n (self,TOPARSER L_POWER,0,TOPARSER Expression_4,0);
}
static STATUS hid302(PRECC_DATA* self) {
PARSER Pre_Gen, Expression_4;
return p_andparse0n (self,TOPARSER Pre_Gen,0,TOPARSER Expression_4,0);
}
static STATUS hid303(PRECC_DATA* self) {
PARSER Decoration, Expression_4;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER Expression_4,0);
}
static STATUS hid304(PRECC_DATA* self) {
PARSER L_HYPHEN, hid303;
return p_andparse0n (self,TOPARSER L_HYPHEN,0,TOPARSER hid303,0);
}
static STATUS hid305(PRECC_DATA* self) {
PARSER L_RIMG, Decoration;
return p_andparse0n (self,TOPARSER L_RIMG,0,TOPARSER Decoration,0);
}
static STATUS hid306(PRECC_DATA* self) {
PARSER Expression_0, hid305;
return p_andparse0n (self,TOPARSER Expression_0,0,TOPARSER hid305,0);
}
static STATUS hid307(PRECC_DATA* self) {
PARSER L_LIMG, hid306;
return p_andparse0n (self,TOPARSER L_LIMG,0,TOPARSER hid306,0);
}
static STATUS hid308(PRECC_DATA* self) {
PARSER Expression_4, hid307;
return p_andparse0n (self,TOPARSER Expression_4,0,TOPARSER hid307,0);
}
static STATUS hid309 (PRECC_DATA* self) {
PARSER hid308, Expression_3;
return p_orparse0n (self,TOPARSER hid308,0,TOPARSER Expression_3,0);
}
static STATUS hid310 (PRECC_DATA* self) {
PARSER hid304, hid309;
return p_orparse0n (self,TOPARSER hid304,0,TOPARSER hid309,0);
}
static STATUS hid311 (PRECC_DATA* self) {
PARSER hid302, hid310;
return p_orparse0n (self,TOPARSER hid302,0,TOPARSER hid310,0);
}
static STATUS hid312 (PRECC_DATA* self) {
PARSER hid301, hid311;
return p_orparse0n (self,TOPARSER hid301,0,TOPARSER hid311,0);
}
STATUS Expression_2A(PRECC_DATA* self) {
PARSER hid312;
P_RETURN((TOPARSER hid312)(self),"Expression_2A");
}
P_END

P_BEGIN
static STATUS hid313(PRECC_DATA* self) {
PARSER Expression_4;
return p_some0n(self,TOPARSER Expression_4,0);
}
STATUS Expression_3(PRECC_DATA* self) {
PARSER hid313;
P_RETURN((TOPARSER hid313)(self),"Expression_3");
}
P_END

/* I'm breaking up expression_4 to catch the postops */

P_BEGIN
static STATUS hid314(PRECC_DATA* self) {
PARSER L_POINT, Var_Name;
return p_andparse0n (self,TOPARSER L_POINT,0,TOPARSER Var_Name,0);
}
static STATUS hid315(PRECC_DATA* self) {
PARSER Expression, L_ESUP;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER L_ESUP,0);
}
static STATUS hid316(PRECC_DATA* self) {
PARSER L_BSUP, hid315;
return p_andparse0n (self,TOPARSER L_BSUP,0,TOPARSER hid315,0);
}
static STATUS hid317 (PRECC_DATA* self) {
PARSER Post_Fun, hid316;
return p_orparse0n (self,TOPARSER Post_Fun,0,TOPARSER hid316,0);
}
static STATUS hid318 (PRECC_DATA* self) {
PARSER hid314, hid317;
return p_orparse0n (self,TOPARSER hid314,0,TOPARSER hid317,0);
}
static STATUS hid319(PRECC_DATA* self) {
PARSER hid318;
return p_option0n(self,TOPARSER hid318,0);
}
static STATUS hid320(PRECC_DATA* self) {
PARSER Expression_4A, hid319;
return p_andparse0n (self,TOPARSER Expression_4A,0,TOPARSER hid319,0);
}
STATUS Expression_4(PRECC_DATA* self) {
PARSER hid320;
P_RETURN((TOPARSER hid320)(self),"Expression_4");
}
P_END

/* I introduce a list of expressions, for brevity */

P_BEGIN
static STATUS hid321(PRECC_DATA* self) {
PARSER L_COMMA, Expression;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Expression,0);
}
static STATUS hid322(PRECC_DATA* self) {
PARSER hid321;
return p_many0n(self,TOPARSER hid321,0);
}
static STATUS hid323(PRECC_DATA* self) {
PARSER Expression, hid322;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER hid322,0);
}
STATUS Expressions(PRECC_DATA* self) {
PARSER hid323;
P_RETURN((TOPARSER hid323)(self),"Expressions");
}
P_END

/* Do we want infixes etc. as Var_Name? */

P_BEGIN
static STATUS hid324(PRECC_DATA* self) {
PARSER Gen_Actuals;
return p_option0n(self,TOPARSER Gen_Actuals,0);
}
static STATUS hid325(PRECC_DATA* self) {
PARSER Var_Name, hid324;
return p_andparse0n (self,TOPARSER Var_Name,0,TOPARSER hid324,0);
}
static STATUS hid326(PRECC_DATA* self) {
PARSER Expressions;
return p_option0n(self,TOPARSER Expressions,0);
}
static STATUS hid327(PRECC_DATA* self) {
PARSER hid326, L_RANGLE;
return p_andparse0n (self,TOPARSER hid326,0,TOPARSER L_RANGLE,0);
}
static STATUS hid328(PRECC_DATA* self) {
PARSER L_LANGLE, hid327;
return p_andparse0n (self,TOPARSER L_LANGLE,0,TOPARSER hid327,0);
}
static STATUS hid329 (PRECC_DATA* self) {
PARSER hid328, Expression_4B;
return p_orparse0n (self,TOPARSER hid328,0,TOPARSER Expression_4B,0);
}
static STATUS hid330 (PRECC_DATA* self) {
PARSER Set_Exp, hid329;
return p_orparse0n (self,TOPARSER Set_Exp,0,TOPARSER hid329,0);
}
static STATUS hid331 (PRECC_DATA* self) {
PARSER Number, hid330;
return p_orparse0n (self,TOPARSER Number,0,TOPARSER hid330,0);
}
static STATUS hid332 (PRECC_DATA* self) {
PARSER hid325, hid331;
return p_orparse0n (self,TOPARSER hid325,0,TOPARSER hid331,0);
}
STATUS Expression_4A(PRECC_DATA* self) {
PARSER hid332;
P_RETURN((TOPARSER hid332)(self),"Expression_4A");
}
P_END

/* try without brackets around lambdas and so on */

P_BEGIN
static STATUS hid333(PRECC_DATA* self) {
PARSER Expressions, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER Expressions,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid334(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid333;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid333,0);
}
static STATUS hid335(PRECC_DATA* self) {
PARSER Expressions;
return p_option0n(self,TOPARSER Expressions,0);
}
static STATUS hid336(PRECC_DATA* self) {
PARSER hid335, L_RBAG;
return p_andparse0n (self,TOPARSER hid335,0,TOPARSER L_RBAG,0);
}
static STATUS hid337(PRECC_DATA* self) {
PARSER L_LBAG, hid336;
return p_andparse0n (self,TOPARSER L_LBAG,0,TOPARSER hid336,0);
}
static STATUS hid338(PRECC_DATA* self) {
PARSER Renaming;
return p_option0n(self,TOPARSER Renaming,0);
}
static STATUS hid339(PRECC_DATA* self) {
PARSER Decoration, hid338;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid338,0);
}
static STATUS hid340(PRECC_DATA* self) {
PARSER Schema_Name, hid339;
return p_andparse0n (self,TOPARSER Schema_Name,0,TOPARSER hid339,0);
}
static STATUS hid341(PRECC_DATA* self) {
PARSER /* ??? */L_THETA, hid340;
return p_andparse0n (self,TOPARSER /* ??? */L_THETA,0,TOPARSER hid340,0);
}
static STATUS hid342(PRECC_DATA* self) {
PARSER Expression_0, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER Expression_0,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid343(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid342;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid342,0);
}
static STATUS hid344 (PRECC_DATA* self) {
PARSER hid343, Schema_Ref;
return p_orparse0n (self,TOPARSER hid343,0,TOPARSER Schema_Ref,0);
}
static STATUS hid345 (PRECC_DATA* self) {
PARSER hid341, hid344;
return p_orparse0n (self,TOPARSER hid341,0,TOPARSER hid344,0);
}
static STATUS hid346 (PRECC_DATA* self) {
PARSER hid337, hid345;
return p_orparse0n (self,TOPARSER hid337,0,TOPARSER hid345,0);
}
static STATUS hid347 (PRECC_DATA* self) {
PARSER hid334, hid346;
return p_orparse0n (self,TOPARSER hid334,0,TOPARSER hid346,0);
}
STATUS Expression_4B(PRECC_DATA* self) {
PARSER hid347;
P_RETURN((TOPARSER hid347)(self),"Expression_4B");
}
P_END

P_BEGIN
static STATUS hid348(PRECC_DATA* self) {
PARSER Expressions;
return p_option0n(self,TOPARSER Expressions,0);
}
static STATUS hid349(PRECC_DATA* self) {
PARSER hid348, L_CLOSESET;
return p_andparse0n (self,TOPARSER hid348,0,TOPARSER L_CLOSESET,0);
}
static STATUS hid350(PRECC_DATA* self) {
PARSER L_OPENSET, hid349;
return p_andparse0n (self,TOPARSER L_OPENSET,0,TOPARSER hid349,0);
}
static STATUS hid351(PRECC_DATA* self) {
PARSER L_AT, Expression;
return p_andparse0n (self,TOPARSER L_AT,0,TOPARSER Expression,0);
}
static STATUS hid352(PRECC_DATA* self) {
PARSER hid351;
return p_option0n(self,TOPARSER hid351,0);
}
static STATUS hid353(PRECC_DATA* self) {
PARSER hid352, L_CLOSESET;
return p_andparse0n (self,TOPARSER hid352,0,TOPARSER L_CLOSESET,0);
}
static STATUS hid354(PRECC_DATA* self) {
PARSER Schema_Text, hid353;
return p_andparse0n (self,TOPARSER Schema_Text,0,TOPARSER hid353,0);
}
static STATUS hid355(PRECC_DATA* self) {
PARSER L_OPENSET, hid354;
return p_andparse0n (self,TOPARSER L_OPENSET,0,TOPARSER hid354,0);
}
static STATUS hid356 (PRECC_DATA* self) {
PARSER hid350, hid355;
return p_orparse0n (self,TOPARSER hid350,0,TOPARSER hid355,0);
}
STATUS Set_Exp(PRECC_DATA* self) {
PARSER hid356;
P_RETURN((TOPARSER hid356)(self),"Set_Exp");
}
P_END

/* FIX ME: Ident could be changed to avoid picking up registered keywords
 * as Var_Name with Expression_4A. Or the check can be in Expression_4A.
 */

P_BEGIN
static STATUS hid357(PRECC_DATA* self) {
PARSER L_WORD, Decoration;
return p_andparse0n (self,TOPARSER L_WORD,0,TOPARSER Decoration,0);
}
STATUS Ident(PRECC_DATA* self) {
PARSER hid357;
P_RETURN((TOPARSER hid357)(self),"Ident");
}
P_END

P_BEGIN
static STATUS hid358 (PRECC_DATA* self) {
PARSER Op_Name, Ident;
return p_orparse0n (self,TOPARSER Op_Name,0,TOPARSER Ident,0);
}
STATUS Decl_Name(PRECC_DATA* self) {
PARSER hid358;
P_RETURN((TOPARSER hid358)(self),"Decl_Name");
}
P_END

P_BEGIN
static STATUS hid359(PRECC_DATA* self) {
PARSER Op_Name, L_CLOSEPAREN;
return p_andparse0n (self,TOPARSER Op_Name,0,TOPARSER L_CLOSEPAREN,0);
}
static STATUS hid360(PRECC_DATA* self) {
PARSER L_OPENPAREN, hid359;
return p_andparse0n (self,TOPARSER L_OPENPAREN,0,TOPARSER hid359,0);
}
static STATUS hid361 (PRECC_DATA* self) {
PARSER hid360, Ident;
return p_orparse0n (self,TOPARSER hid360,0,TOPARSER Ident,0);
}
STATUS Var_Name(PRECC_DATA* self) {
PARSER hid361;
P_RETURN((TOPARSER hid361)(self),"Var_Name");
}
P_END

P_BEGIN
static STATUS hid362(PRECC_DATA* self) {
PARSER In_Sym, L_UNDERSCORE;
return p_andparse0n (self,TOPARSER In_Sym,0,TOPARSER L_UNDERSCORE,0);
}
static STATUS hid363(PRECC_DATA* self) {
PARSER L_UNDERSCORE, hid362;
return p_andparse0n (self,TOPARSER L_UNDERSCORE,0,TOPARSER hid362,0);
}
static STATUS hid364(PRECC_DATA* self) {
PARSER Pre_Sym, L_UNDERSCORE;
return p_andparse0n (self,TOPARSER Pre_Sym,0,TOPARSER L_UNDERSCORE,0);
}
static STATUS hid365(PRECC_DATA* self) {
PARSER L_UNDERSCORE, Post_Sym;
return p_andparse0n (self,TOPARSER L_UNDERSCORE,0,TOPARSER Post_Sym,0);
}
static STATUS hid366(PRECC_DATA* self) {
PARSER L_RIMG, Decoration;
return p_andparse0n (self,TOPARSER L_RIMG,0,TOPARSER Decoration,0);
}
static STATUS hid367(PRECC_DATA* self) {
PARSER L_UNDERSCORE, hid366;
return p_andparse0n (self,TOPARSER L_UNDERSCORE,0,TOPARSER hid366,0);
}
static STATUS hid368(PRECC_DATA* self) {
PARSER L_LIMG, hid367;
return p_andparse0n (self,TOPARSER L_LIMG,0,TOPARSER hid367,0);
}
static STATUS hid369(PRECC_DATA* self) {
PARSER L_UNDERSCORE, hid368;
return p_andparse0n (self,TOPARSER L_UNDERSCORE,0,TOPARSER hid368,0);
}
static STATUS hid370(PRECC_DATA* self) {
PARSER L_HYPHEN, Decoration;
return p_andparse0n (self,TOPARSER L_HYPHEN,0,TOPARSER Decoration,0);
}
static STATUS hid371 (PRECC_DATA* self) {
PARSER hid369, hid370;
return p_orparse0n (self,TOPARSER hid369,0,TOPARSER hid370,0);
}
static STATUS hid372 (PRECC_DATA* self) {
PARSER hid365, hid371;
return p_orparse0n (self,TOPARSER hid365,0,TOPARSER hid371,0);
}
static STATUS hid373 (PRECC_DATA* self) {
PARSER hid364, hid372;
return p_orparse0n (self,TOPARSER hid364,0,TOPARSER hid372,0);
}
static STATUS hid374 (PRECC_DATA* self) {
PARSER hid363, hid373;
return p_orparse0n (self,TOPARSER hid363,0,TOPARSER hid373,0);
}
STATUS Op_Name(PRECC_DATA* self) {
PARSER hid374;
P_RETURN((TOPARSER hid374)(self),"Op_Name");
}
P_END

P_BEGIN
static STATUS hid375 (PRECC_DATA* self) {
PARSER In_Gen, In_Rel;
return p_orparse0n (self,TOPARSER In_Gen,0,TOPARSER In_Rel,0);
}
static STATUS hid376 (PRECC_DATA* self) {
PARSER In_Fun, hid375;
return p_orparse0n (self,TOPARSER In_Fun,0,TOPARSER hid375,0);
}
STATUS In_Sym(PRECC_DATA* self) {
PARSER hid376;
P_RETURN((TOPARSER hid376)(self),"In_Sym");
}
P_END

P_BEGIN
static STATUS hid377 (PRECC_DATA* self) {
PARSER Pre_Gen, Pre_Rel;
return p_orparse0n (self,TOPARSER Pre_Gen,0,TOPARSER Pre_Rel,0);
}
STATUS Pre_Sym(PRECC_DATA* self) {
PARSER hid377;
P_RETURN((TOPARSER hid377)(self),"Pre_Sym");
}
P_END

P_BEGIN
STATUS Post_Sym(PRECC_DATA* self) {
PARSER Post_Fun;
P_RETURN((TOPARSER Post_Fun)(self),"Post_Sym");
}
P_END

P_BEGIN
static STATUS hid378(PRECC_DATA* self) {
PARSER Stroke;
return p_many0n(self,TOPARSER Stroke,0);
}
STATUS Decoration(PRECC_DATA* self) {
PARSER hid378;
P_RETURN((TOPARSER hid378)(self),"Decoration");
}
P_END

P_BEGIN
static STATUS hid379(PRECC_DATA* self) {
PARSER L_COMMA, Ident;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Ident,0);
}
static STATUS hid380(PRECC_DATA* self) {
PARSER hid379;
return p_many0n(self,TOPARSER hid379,0);
}
static STATUS hid381(PRECC_DATA* self) {
PARSER hid380, L_CLOSEBRACKET;
return p_andparse0n (self,TOPARSER hid380,0,TOPARSER L_CLOSEBRACKET,0);
}
static STATUS hid382(PRECC_DATA* self) {
PARSER Ident, hid381;
return p_andparse0n (self,TOPARSER Ident,0,TOPARSER hid381,0);
}
static STATUS hid383(PRECC_DATA* self) {
PARSER L_OPENBRACKET, hid382;
return p_andparse0n (self,TOPARSER L_OPENBRACKET,0,TOPARSER hid382,0);
}
STATUS Gen_Formals(PRECC_DATA* self) {
PARSER hid383;
P_RETURN((TOPARSER hid383)(self),"Gen_Formals");
}
P_END

P_BEGIN
static STATUS hid384(PRECC_DATA* self) {
PARSER L_COMMA, Expression;
return p_andparse0n (self,TOPARSER L_COMMA,0,TOPARSER Expression,0);
}
static STATUS hid385(PRECC_DATA* self) {
PARSER hid384;
return p_many0n(self,TOPARSER hid384,0);
}
static STATUS hid386(PRECC_DATA* self) {
PARSER hid385, L_CLOSEBRACKET;
return p_andparse0n (self,TOPARSER hid385,0,TOPARSER L_CLOSEBRACKET,0);
}
static STATUS hid387(PRECC_DATA* self) {
PARSER Expression, hid386;
return p_andparse0n (self,TOPARSER Expression,0,TOPARSER hid386,0);
}
static STATUS hid388(PRECC_DATA* self) {
PARSER L_OPENBRACKET, hid387;
return p_andparse0n (self,TOPARSER L_OPENBRACKET,0,TOPARSER hid387,0);
}
STATUS Gen_Actuals(PRECC_DATA* self) {
PARSER hid388;
P_RETURN((TOPARSER hid388)(self),"Gen_Actuals");
}
P_END

/* I am adding decorations in to the basics here, as they are never naked */

/* maybe only those things that have been registered can qualify here?  */

extern int          is_postop  (int x);
extern int          is_inrel   (int x);
extern int          is_ingen   (int x);
extern int          is_prerel  (int x);
extern int          is_pregen  (int x);
extern int          is_inop    (int x);
extern int          is_ignore  (int x);       

P_BEGIN
static STATUS hid389(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_inop((int)(TOVALUE x)));
}
static STATUS hid390(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid391(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid390;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid390,P_SZ(1,1),x);
}
static STATUS hid392(PRECC_DATA* self,VALUE x) {
PARSER hid389, hid391;
return p_andparse0n (self,TOPARSER hid389,P_SZ(1,1),x,TOPARSER hid391,P_SZ(1,1),x);
}
static STATUS hid393(PRECC_DATA* self) {
PARSER L_WORD, hid392; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid392)(self,x));
return p_tok;
}
STATUS In_Fun(PRECC_DATA* self) {
PARSER hid393;
P_RETURN((TOPARSER hid393)(self),"In_Fun");
}
P_END

P_BEGIN
static STATUS hid394(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_ingen((int)(TOVALUE x)));
}
static STATUS hid395(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid396(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid395;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid395,P_SZ(1,1),x);
}
static STATUS hid397(PRECC_DATA* self,VALUE x) {
PARSER hid394, hid396;
return p_andparse0n (self,TOPARSER hid394,P_SZ(1,1),x,TOPARSER hid396,P_SZ(1,1),x);
}
static STATUS hid398(PRECC_DATA* self) {
PARSER L_WORD, hid397; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid397)(self,x));
return p_tok;
}
STATUS In_Gen(PRECC_DATA* self) {
PARSER hid398;
P_RETURN((TOPARSER hid398)(self),"In_Gen");
}
P_END

P_BEGIN
static STATUS hid399(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_inrel((int)(TOVALUE x)));
}
static STATUS hid400(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid401(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid400;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid400,P_SZ(1,1),x);
}
static STATUS hid402(PRECC_DATA* self,VALUE x) {
PARSER hid399, hid401;
return p_andparse0n (self,TOPARSER hid399,P_SZ(1,1),x,TOPARSER hid401,P_SZ(1,1),x);
}
static STATUS hid403(PRECC_DATA* self) {
PARSER L_WORD, hid402; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid402)(self,x));
return p_tok;
}
STATUS In_Rel(PRECC_DATA* self) {
PARSER hid403;
P_RETURN((TOPARSER hid403)(self),"In_Rel");
}
P_END

P_BEGIN
static STATUS hid404(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_pregen((int)(TOVALUE x)));
}
static STATUS hid405(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid406(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid405;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid405,P_SZ(1,1),x);
}
static STATUS hid407(PRECC_DATA* self,VALUE x) {
PARSER hid404, hid406;
return p_andparse0n (self,TOPARSER hid404,P_SZ(1,1),x,TOPARSER hid406,P_SZ(1,1),x);
}
static STATUS hid408(PRECC_DATA* self) {
PARSER L_WORD, hid407; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid407)(self,x));
return p_tok;
}
STATUS Pre_Gen(PRECC_DATA* self) {
PARSER hid408;
P_RETURN((TOPARSER hid408)(self),"Pre_Gen");
}
P_END

P_BEGIN
static STATUS hid409(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_prerel((int)(TOVALUE x)));
}
static STATUS hid410(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid411(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid410;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid410,P_SZ(1,1),x);
}
static STATUS hid412(PRECC_DATA* self,VALUE x) {
PARSER hid409, hid411;
return p_andparse0n (self,TOPARSER hid409,P_SZ(1,1),x,TOPARSER hid411,P_SZ(1,1),x);
}
static STATUS hid413(PRECC_DATA* self) {
PARSER L_WORD, hid412; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid412)(self,x));
return p_tok;
}
STATUS Pre_Rel(PRECC_DATA* self) {
PARSER hid413;
P_RETURN((TOPARSER hid413)(self),"Pre_Rel");
}
P_END

P_BEGIN
static STATUS hid414(PRECC_DATA* self,VALUE x) {
return p_test0(self,is_postop((int)(TOVALUE x)));
}
static STATUS hid415(PRECC_DATA* self,VALUE x) {
return p_atch0(self,/* VALUE */ x );
}
static STATUS hid416(PRECC_DATA* self,VALUE x) {
PARSER Decoration, hid415;
return p_andparse0n (self,TOPARSER Decoration,0,TOPARSER hid415,P_SZ(1,1),x);
}
static STATUS hid417(PRECC_DATA* self,VALUE x) {
PARSER hid414, hid416;
return p_andparse0n (self,TOPARSER hid414,P_SZ(1,1),x,TOPARSER hid416,P_SZ(1,1),x);
}
static STATUS hid418(PRECC_DATA* self) {
PARSER L_WORD, hid417; VALUE x;
static STATUS p_tok;
P_PSTAR(x,(TOPARSER L_WORD)(self),(TOPARSER hid417)(self,x));
return p_tok;
}
STATUS Post_Fun(PRECC_DATA* self) {
PARSER hid418;
P_RETURN((TOPARSER hid418)(self),"Post_Fun");
}
P_END

P_BEGIN
STATUS Stroke(PRECC_DATA* self) {
PARSER L_STROKE;
P_RETURN((TOPARSER L_STROKE)(self),"Stroke");
}
P_END

P_BEGIN
STATUS Schema_Name(PRECC_DATA* self) {
PARSER L_WORD;
P_RETURN((TOPARSER L_WORD)(self),"Schema_Name");
}
P_END

P_BEGIN
STATUS Number(PRECC_DATA* self) {
PARSER L_NUMBER;
P_RETURN((TOPARSER L_NUMBER)(self),"Number");
}
P_END

MAIN(Specification)
